' Started 	April 26th 2014 - 13:00 GMT
' Ended		April 26th 2014 - 14:30 GMT

#GLFW_WINDOW_TITLE="The Spikes Beneath"
#GLFW_WINDOW_RESIZABLE=True
#GLFW_WINDOW_FULLSCREEN=False
#GLFW_USE_MINGW=True

#ANDROID_APP_LABEL="Beneath"
#ANDROID_APP_PACKAGE="com.AGameAWeek.SpikesBelow"
#ANDROID_SCREEN_ORIENTATION="landscape" ' portrait, landscape or user
#ANDROID_GAMEPAD_ENABLED=True
#ANDROID_VERSION_CODE="1"
#ANDROID_VERSION_NAME="1.0"

#MOJO_IMAGE_FILTERING_ENABLED="false"

Import mojo
#If TARGET="ios"
	Import brl.gamecenter
#End

#If Not((LANG<>"cpp" And LANG<>"java" And TARGET<>"html5") Or TARGET="win8")
	Import brl.httprequest
#End

Import JMTrackr
Public Global HasMusic=0		' Use this for JMTrackr music	(uses /inst/ and /tunes/ folders)
Public Global HasMusicStream=1	' Use this for mp3/ogg music	(uses /sfx/ folder)



Public Global isOuya=0	' Set to 1 when compiling for OUYA.
Const DisableOuya=0		' Switch to 1 to disable OUYA, under "this doesn't look like OUYA" circumstances.
						' Currently it only checks for screen resolution, since I'm not too fussy, myself.
						' but feel free to add more complex checks and things..

						' If (wasOuya=1 and isOuya=0) then "disable things for other android users"..

Public Global jscrw:Float=640
Public Global jscrh:Float=480

Public Global rawscrw:Float=640
Public Global rawscrh:Float=480


Public Global overscan:Float=0	
			' Overscan notes
				' Adds a border before render scaling, to allow for "margins" on overscan systems.
				' Generally works well, but the bottom doesn't seem to scale brilliantly!
				' other than that, though, all should work nicely, as long as you've nothing that appears/disappears too close to the edge.

Public Global DebugMode=0
Public Global OnScreenControls=0
Public Global AccelerometerControls=0

Const SFX_Jingle=96 	' Change this to the game's jingle sfx number.

Const iCadeAllowed=1	' Switch this off if you don't want the iCade Logo on the titlescreen.
						' Note that setting OUYA to 1 will disable the iCade logo/options.
						
Const MaxGames=1	' Number of Games / Difficulties / whatever
Const MaxHigh=10	' Number of Highscores per Game
Const MaxBadges=0	' Number of Achievable Badges

Const LeaderBoard_ID$="com.agameaweek.AGAW_GameName_Score_"
Const Badge_ID$="com.agameaweek.AGAW_GameName_Badge_"

#If Not((LANG<>"cpp" And LANG<>"java" And TARGET<>"html5") Or TARGET="win8")
	Const HTTPAvail=1
#Else
	Const HTTPAvail=0
#End

#If TARGET="ios"
	Const MaxSprites=2500
	Const MaxChannels=32
	
#Elseif TARGET="html5"
	Const MaxSprites=2500
	Const MaxChannels=8


#Else
	Const MaxSprites=2500
	Const MaxChannels=32
#End


#Rem
	Sets
	[5] Sound On/Off
	[10][11][12] DPad 
	[14] Overscan on OUYA
#End Rem


' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
Public Global CreditText:String[]=[	"",
									"A Game by","@Jayenkai",
									"AGameAWeek.com",
									"","-=-=-","",
									"Developed using","Monkey-X",
									"Monkey-X.com",
									"","-=-=-","",
									"Graphics","",
									"Most graphics by","Jayenkai","",
									"Font : EditUndo","by Brian Kent","Lowercase added by","Jayenkai","",
									"","-=-=-","",
									"Audio","",
									"Sound and Music by","Jayenkai",
									"using FLStudio,","KORG Gadget,","SFXr,","Cool Edit",
									"or whatever else","is handy!",
									"","-=-=-","",
									"Thanks to","CodersRule","Spinal_Code","Rockford","CaffeineKid","JL235","and everyone else","at Socoder.net",

"","-=-=-","End"]
' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-


Public Global iCadeControls=0

#If Not((LANG<>"cpp" And LANG<>"java" And TARGET<>"html5") Or TARGET="win8")
Class MyApp Extends App Implements IOnHttpRequestComplete
#Else
Class MyApp Extends App
#End
	Field MusicPlayer:JMPlayer=New JMPlayer

	Field Score,ShowScore:Int
	Field EndofGame,Ending:Int	

	Field wr=0
	Field GameMode,GameType:Int
	Field MenuIn,BarWide:Float
	Field MenuScroll#,MenuScrollAim#,MenuAccel#,MenuPush#,MenuSelect,CogSpin#,MenuFocus
	
	
	Field plr#[512],ID
	
	Field scrx#,scry#,aimx#,aimy#,spikex#
	
	Field OptionsOn,OptionsIn,OptionsScroll,Omdis,Okdis,OptionsSelect
	
	Field RandomSeed:Int
	Field FloorAt#
	
	Field grid[512]
	
	Field MaxSpike,SpikeTo,SpikeCount,SpikePassed,Combo,ComboTick#,SCombo
	
	Field Part#[5100]
	Field MostParticles=250
	Field Star#[5100]
	Field MostStars=100
	
	Field ScreenshotMode=0

' Credits
	Field CreditsOn=0
	Field CreditsIn=0
	Field credx,credy
	Field credscrA#=0
	Field credscrB=0
	
	
	Field BadgesOn=0
	Field BadgesScr#,BadgesAimScr#
	
	Field ToSprites:Int
	Field Orientation:Int
	Field MenuOrientation:Int

	Field lmsr,lmsu,fpsr,fpsu,fpsra,fpsua:Int
	Field ControlX#,ControlY#,ControlX2#,ControlY2#

	Field sfx:Sound[100]
	Field chan:Int[MaxChannels+1]
	Field LChan:Int

	Field Set:Int[25]
	Field High:Int[MaxGames*MaxHigh*5]
	Field Badge:Bool[256]
	Field BadgeSent:Bool[256]
	
	Field img:Image[100]
	Field imgd:Int[300]
	Field sprt:Float[(MaxSprites)*15]
	Field sprtup:Int

	Field Paused,PausedIn,PausedMove,PausedMenu:Int

	Field a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z:Int
	Field mx,my,mwx,mwy,mcx,mcy,md,mdAll,mdAll2,mdel,mdis,kdis:Int

	Field tx:Int[10]
	Field ty:Int[10]
	Field td:Int[10]
	Field but:Int[20]
	Field DPadX:Int,DPadY:Int,DPadZ:Float

	Field BadgeGet:Int[15]
	Field BadgeTick:Int[15]

	Field scaleX:Float,scaleY:Float

	Field J_Loader,J_WW,J_WH,FirstLoad_Jingle:Int
	Field J_AX#,J_AY#,J_AXU#,J_AYU#,J_AX_Level#,J_AY_Level#
	Field J_Font:Int
	Field J_ClipA#,J_ClipB#,J_ClipC#,J_ClipD#
	Field J_CLS_R:Float,J_CLS_G:Float,J_CLS_B:Float,J_CLS_A:Float
	Field J_Scale_X:Float,J_Scale_Y:Float,J_Rot:Float
	Field J_R:Float,J_G:Float,J_B:Float,J_A:Float,J_Blend:Int
	Field J_Fullscreen:Int
	Field J_MusicPlaying:Int
	

	Field J_Retina:Int,J_RetinaD:Float
	Field wasOuya=isOuya

' Internetting
#If Not((LANG<>"cpp" And LANG<>"java" And TARGET<>"html5") Or TARGET="win8")
	Field get_req:HttpRequest
#End
	Field GotURL:Int
	Field URLData$="N/A"
	
' GameCentering
#If TARGET="ios"
	Field gamectr:GameCenter
#End


	Method BadgeID$(fn)
		Select fn
			Case 0
				Return "Test Badge|This is a Test Badge which has no purpose."
		End Select
	End
	
	
	
	' Main Stuff
	
	Method Loader()
		J_Retina=1;J_RetinaD=1;		
		If DeviceWidth()>630 Or DeviceHeight()>630 Then J_Retina=2;J_RetinaD=0.5
		If DeviceWidth()>1230 Or DeviceHeight()>1230 Then J_Retina=4;J_RetinaD=0.25

		'Print(J_Loader)
			Select J_Loader
			' Default Images/Icons
				Case 1
					LoadImg(97,"common/icons",32,32,16,Image.MidHandle)
					LoadSFX(SFX_Jingle)
				Case 2
					LoadImg(95,"common/Buttons",64,64,16,Image.MidHandle)
				Case 3
					LoadImg(94,"common/dpad",32,32,16,Image.MidHandle)
				Case 4
					LoadImg(93,"common/AGAWLogo",256,256,1,Image.MidHandle)
					If FirstLoad_Jingle=0 Then PlaySFX(SFX_Jingle);FirstLoad_Jingle=1
				Case 5
					LoadImg(91,"common/Testcard_Circle",256,256,1,Image.MidHandle)

			' Default Font	
				Case 6
					LoadFont(90,"fonts/editundo",7,10)
					

								
			' Default SFX
				Case 7
					LoadSFX(1)
				Case 8
					If SFX_Jingle<>95 Then LoadSFX(95)

				Case 9
					LoadSFX(98)	
				Case 10
					LoadSFX(99)
				
			' Menu and Logo
				Case 11
					LoadImg(99,"menu",256,256,4,Image.MidHandle)
				Case 12
					LoadImg(98,"logo",256,128,1,Image.MidHandle)
				Case 13
					LoadImg(96,"parts",8,8,256,Image.MidHandle)
				Case 14
					LoadImg(80,"BadgesA",64,64,64,Image.MidHandle)

			' Your stuff
				Case 15
					LoadImg(1,"world001",32,32,40,Image.MidHandle)
				Case 16
					LoadSFX(5)
				Case 17
					LoadSFX(6)
				Case 18
					LoadSFX(2)
				Case 19
					LoadSFX(3)
				Case 20
					LoadSFX(4)
				Case 21
					LoadSFX(10)
					
				Default
					J_Loader=0
			End Select
			
		If J_Loader>0 Then J_Loader=J_Loader+1
		WaitStart(1)
	End

	
	Method Reload()
		J_CLS_R=0;J_CLS_G=0;J_CLS_B=0;J_CLS_A=1;
		J_Retina=1;J_RetinaD=1;
		
		If DeviceWidth()>630 Or DeviceHeight()>630 Then J_Retina=2;J_RetinaD=0.5
		If DeviceWidth()>1230 Or DeviceHeight()>1230 Then J_Retina=4;J_RetinaD=0.25
		LoadImg(93,"common/AGAWLogo",256,256,1,Image.MidHandle)
		LoadFont(90,"fonts/editundo",7,10)

		J_Loader=1
	End
	
	
	' Stringy Things
	
	Method MyNth$()
		' Compares Score to Highscores,
		' Places position into n variable
		' Returns "Xth" string.
		Local fout$
		n=0
		For m=0 To 9
		If Score>=High[((GameType-1)*MaxHigh)+m] And n=0 Then n=m+1
		Next
		Select n
			Case 1 fout="1st!"
			Case 2 fout="2nd"
			Case 3 fout="3rd"
			Case 4 fout="4th"
			Case 5 fout="5th"
			Case 6 fout="6th"
			Case 7 fout="7th"
			Case 8 fout="8th"
			Case 9 fout="9th"
			Case 10 fout="10th"
		End Select
		Return fout
	End
	
	Method GetFlag(fn,ff)
		Return ((fn Shr (ff-1)) & 1)
	End
	Method SetFlag(fn,ff,ft)
		If ft=0
			Return fn & ($FFFFFFFF-(1 Shl (ff-1)))
		Endif
		If ft=1
			Return fn | (1 Shl (ff-1))
		Endif
	End

	Function WhichWayDoIGo(ImAt#,WantToGo#,BotLimit=0,TopLimit=359)
			'ImAt - My Current Angle.
			'WanttoGo - The angle I want To face.
				'BotLimit - The bottommost point
				'TopLimit - The topmost point
			
			
	Local dip#=((TopLimit-BotLimit)+1)
		'First check that the angles are between Top And Bottom.
		
		ImAt=ImAt Mod dip
		If ImAt<0 Then ImAt=dip+ImAt
		
		WantToGo=WantToGo Mod dip
		If WantToGo<0 Then WantToGo=dip+WantToGo
		
		'Find the difference
		Local Difference#=(WantToGo-ImAt)
	
		Difference=Difference Mod dip
		If Difference<0 Then Difference=dip+Difference
	
		Difference=Difference+BotLimit
		
		'Then decide If it's bigger or less than the mid-point..
		Local out=Difference
		If Difference>((TopLimit-BotLimit)/2)+BotLimit Then out=-((TopLimit-BotLimit)-Difference)
	
		
		'Sorted...
	
		Return out
	End


	Method Morph#(fa#,fb#,fperc#)
		' Finds the number that's fperc% between fa and fb
		Local fd#,fout#
		fd=fb-fa
		fout=(fd*fperc)/100.0
		Return fout+fa
	End

	Method Rand(fa#,fb#)
		Return Floor(Rnd(fa,fb+0.99))
	End 
	
	Method rstr$(fn,fd=8,ftxt$=" ")
		' Right align a number (fn),
		' with fd characters in the returned string.
		' padded using ftxt$
		  ' eg rstr$(123,8,"0") = "00000123"
		  '    rstr$(123,9," ") = "      123"
		 
		Local fout$=ftxt
		For n=1 To fd
		fout=fout+ftxt
		Next
		
		fout=fout+fn
		Return fout[-fd..]
	End
	
	Method SeekXML$(ftxt$,fseek$)	
	Local ff,fa,fb,fn,ftmp$,ftxtUpper$=ftxt.ToUpper()
		fseek=" "+fseek.ToUpper()+"="
		ff=ftxtUpper.FindLast(fseek)
		If ff>-1
			fa=ftxt.Find(ftmp.FromChar(34),ff+1)
			fb=ftxt.Find(ftmp.FromChar(34),fa+1)
			If fa>-1 And fb>-1
				For fn=fa+1 To fb-1
				ftmp=ftmp+ftxt.FromChar(ftxt[fn])
				Next
			Endif
			Return ftmp
		Endif
		If ff=-1 Then Return "-=-"
	End Method


	Method JNKrunch$(ftxt$)
	Local fout$=""
	Local ftxt2$=""
	
		p=0
		s=1
		v=ftxt[0]
		
		For n=1 To ftxt.Length()-1
			i=ftxt[n]
			u=s;If s>26 Then u=u+6
			If i=v
				s=s+1
				If s>52
					ftxt2=ftxt2.FromChar(u+64);fout=fout+ftxt2
					ftxt2=ftxt2.FromChar(v);fout=fout+ftxt2
					s=1;v=i;p=p+1
					If p=10 Then fout=fout+" ";p=0					
				Endif
			Endif
			
			If i<>v
				ftxt2=ftxt2.FromChar(u+64);fout=fout+ftxt2
				ftxt2=ftxt2.FromChar(v);fout=fout+ftxt2
				s=1;v=i;p=p+1
				If p=10 Then fout=fout+" ";p=0					
			Endif			
		Next

		u=s;If s>26 Then u=u+6
		ftxt2=ftxt2.FromChar(u+64);fout=fout+ftxt2
		ftxt2=ftxt2.FromChar(v);fout=fout+ftxt2
	
	Return fout					
	End
	
	Method JuNKrunch$(ftxt$)
	Local fout$=""
	Local ftxt2$=""
	
		n=0
		f=0
		Repeat
			d=0
			c=ftxt[n]
			s=c-64
			If c>90 Then s=c-70
			If c<65 Or c>122 Then d=1
			
			If d=0
				n=n+1
				ftxt2=ftxt2.FromChar(ftxt[n])
				For m=1 To s
					fout=fout+ftxt2
				Next
			Endif
			n=n+1
			If n>=ftxt.Length() Then f=1
		Until f=1
	
	Return fout
	End
	
	
	' Loading
	
	Method LoadImg(fi,file$,width,height,frames,flags)
		If J_Retina=2 Then file=file+"-hd"
		If J_Retina=4 Then file=file+"-hd2"
		file=file+".png"
		img[fi]=Null;
		img[fi]=LoadImage(file,width*J_Retina,height*J_Retina,frames,flags)
		imgd[fi*3]=width*J_Retina
		imgd[fi*3+1]=height*J_Retina
		imgd[fi*3+2]=frames
	End


	Method LoadImgRaw(fi,file$,width,height,frames,flags)
		file=file+".png"
		img[fi]=Null;
		img[fi]=LoadImage(file,width,height,frames,flags)
		imgd[fi*3]=width
		imgd[fi*3+1]=height
		imgd[fi*3+2]=frames
	End

	
	Method LoadFont(fi,file$,fw,fh)		
		If J_Retina=2 Then file=file+"-hd"
		If J_Retina=4 Then file=file+"-hd2"
		file=file+".png"
		img[fi]=LoadImage(file,16*J_Retina,16*J_Retina,128,Image.MidHandle)
		imgd[fi*3]=fw'*J_Retina
		imgd[fi*3+1]=fh'*J_Retina
		imgd[fi*3+2]=128		
		J_Font=fi
	End

	Method OnCreate()
		If isOuya=1 Then overscan=64
		J_Fullscreen=0
		FirstLoad_Jingle=0
		
		GameMode=1;
		SetUpdateRate 60
		J_WW=DeviceWidth();J_WH=DeviceHeight()

#If TARGET="ios"
		gamectr=GameCenter.GetGameCenter()
		gamectr.StartGameCenter
#End
#If TARGET="html5"
	HasMusic=0
#End

		If HasMusic=1 Then MusicPlayer.JM_Init( MaxChannels,4,3,3,4)

		J_AX_Level=0;J_AY_Level=0;
		
#If TARGET="html5" Or TARGET="flash"
		J_CLS_R=0;J_CLS_G=0;J_CLS_B=0;J_CLS_A=1;
		J_Retina=1;J_RetinaD=1;		
		If DeviceWidth()>630 Or DeviceHeight()>630 Then J_Retina=2;J_RetinaD=0.5
		If DeviceWidth()>1230 Or DeviceHeight()>1230 Then J_Retina=4;J_RetinaD=0.25

		LoadImg(93,"common/AGAWLogo",256,256,1,Image.MidHandle)
		LoadFont(90,"fonts/editundo",7,10)

		SetUpdateRate 6
		GameMode=5
#Else
		Reload()
#End
	
		GameType=2
		MenuIn=-32
		ToSprites=50
		Paused=0;PausedMove=-1;PausedIn=-64
		
		For n=0 To 14
			BadgeGet[n]=0;BadgeTick[n]=0;
		Next
		For n=0 To 127
			Badge[n]=False
		Next
		
		For n=0 To 18
			but[n]=0
		Next
		
		For n=0 To 24
			Set[n]=0
		Next
		Set[5]=1
		
		For n=0 To MaxGames*MaxHigh
			High[n]=0
		Next
		
		Load()
		
		For n=0 To MaxChannels
			chan[n]=n
		Next
	End
	
	Method OnRender()
		If HasMusic=1 Then MusicPlayer.JM_Alive_R()
		
		If (Millisecs()-lmsr)>0 Then fpsr=1000/(Millisecs()-lmsr)
		fpsra=((fpsra*9)+fpsr)/10
		lmsr=Millisecs()
		
		SetColor(J_CLS_R,J_CLS_G,J_CLS_B)
		SetAlpha(J_CLS_A)
		DrawRect(-1,-1,DeviceWidth()+2,DeviceHeight()+2)
		SetColor(255,255,255)
		SetAlpha(1)
		
		If J_WW<>DeviceWidth() Or J_WH<>DeviceHeight()
			J_Loader=1
			J_WW=DeviceWidth();J_WH=DeviceHeight()
		Endif
		
		If (J_WW<>1920 Or J_WH<>1080) And DisableOuya=1 Then isOuya=0
		
		scaleX=Float(DeviceWidth()-(overscan*2))/rawscrw
		scaleY=Float(DeviceHeight()-(overscan*2))/rawscrh
		Local rscaleX#,rscaleY#
		rscaleX=Float(DeviceWidth())/rawscrw
		rscaleY=Float(DeviceHeight())/rawscrh
		
		r=1
		If Abs(scaleY-1)<Abs(scaleX-1) Then r=2
		If scaleX>scaleY Then r=1
		If scaleY>scaleX Then r=2
		
		If r=2 Then scaleX=scaleY;rscaleX=rscaleY;jscrw=DeviceWidth()/rscaleX;jscrh=DeviceHeight()/rscaleX
		If r=1 Then scaleY=scaleX;rscaleY=rscaleX;jscrw=DeviceWidth()/rscaleX;jscrh=DeviceHeight()/rscaleX
		
		Orientation=1;If jscrh>jscrw Then Orientation=0


	
		Local o2#=overscan*(Float(DeviceHeight)/Float(DeviceWidth()))
		If sprtup>0
			For n=0 To sprtup-15 Step 15
				SetAlpha(sprt[n+7])
				SetColor(sprt[n+10],sprt[n+11],sprt[n+12])
#If TARGET<>"android"
				SetBlend(AlphaBlend);If sprt[n+13]=3 Then SetBlend(AdditiveBlend)
#End

				Select sprt[n]
				Case -3717
					DrawRect((sprt[n+1])*scaleX+overscan,(sprt[n+2])*scaleY+o2,sprt[n+4]*scaleX,sprt[n+5]*scaleY)
				Case -3716
					DrawEllipse((sprt[n+1])*scaleX+overscan,(sprt[n+2])*scaleY+o2,sprt[n+4]*scaleX,sprt[n+5]*scaleY)
				Case -3715
					DrawLine((sprt[n+1])*scaleX+overscan,(sprt[n+2])*scaleY+o2,(sprt[n+4])*scaleX+overscan,(sprt[n+5])*scaleY+o2)

				Default
					If sprt[n]>-1
'#If TARGET="html5"
'						SetColor(255,255,255)
'#End
						If img[sprt[n]]<>Null Then DrawImage(img[sprt[n]],(sprt[n+1])*scaleX+overscan,(sprt[n+2])*scaleY+o2,sprt[n+3],(sprt[n+4]*scaleX)*J_RetinaD,(sprt[n+5]*scaleY)*J_RetinaD,sprt[n+6])
					Endif
				End Select
			Next
		End

			
		SetAlpha(0.5)
		SetColor(255,255,255)	
	End
	
	' ******** Sonic

	Method LoadSFX(fs)
		If fs<10 Then sfx[fs]=LoadSound("sfx/00"+fs+".wav")
		If fs>9 And fs<100 Then sfx[fs]=LoadSound("sfx/0"+fs+".wav")
		If fs>99 Then sfx[fs]=LoadSound("sfx/"+fs+".wav")
	End

	Method PlaySFX(fs,fpitch#=1,fvol#=1,fpan#=0)
		If Set[5]=1 Or Set[5]=2
			If MaxChannels>8 Then LChan=(LChan+1) Mod (MaxChannels-8)
			If MaxChannels<9 Then LChan=(LChan+1) Mod (MaxChannels)
			If LChan<0 Then LChan=0
			If LChan>MaxChannels-1 Then LChan=0
			
			StopChannel(chan[LChan])
			PlaySound(sfx[fs],chan[LChan],0)
			SetChannelRate(chan[LChan],fpitch)
			SetChannelVolume(chan[LChan],fvol)
			SetChannelPan(chan[LChan],fpan)
		Endif
	End
	
	Method PlayTune(fname$,floop=1)
fname="sfx/"+fname

#If TARGET<>"ios"
	fname=fname+".ogg"
#End
#If TARGET="ios"
	fname=fname+".mp3"
#End

If J_MusicPlaying<>0
	StopMusic();J_MusicPlaying=0
End
If J_MusicPlaying=0 And (Set[5]=1 Or Set[5]=3)
	PlayMusic(fname,floop)
	J_MusicPlaying=1
Endif
	End
	
	Method StopTune()
StopMusic();J_MusicPlaying=0
	End
	
	' **************   Artsy Fartsy
	
	Method ResetDraw()
		J_Scale_X=1;J_Scale_Y=1;
		J_Rot=0;
		J_R=255;J_G=255;J_B=255;J_A=1;J_Blend=1
	End

	Method Ink(fn,fd=1)
	Local fr#,fg#,fb#
	Select fn
		Case 1	fr=1;fg=0.1;fb=0.1
		Case 2	fr=1;fg=0.5;fb=0.1
		Case 3	fr=1;fg=1;fb=0.1
		Case 4	fr=0.1;fg=1;fb=0.1
		Case 5	fr=0.1;fg=1;fb=1
		Case 6	fr=0.1;fg=0.1;fb=1
		Case 7	fr=0.5;fg=0.1;fb=1
		Case 8	fr=1;fg=0.1;fb=0.5
		Case 9	fr=1;fg=1;fb=1
		Default	fr=0.3;fg=0.3;fb=0.3
	End Select
	fr=(fr*fd)*255
	fg=(fg*fd)*255
	fb=(fb*fd)*255
	
	If fr<0 Then fr=0
	If fr>255 Then fr=255
	If fg<0 Then fg=0
	If fg>255 Then fg=255
	If fb<0 Then fb=0
	If fb>255 Then fb=255
	J_R=fr;J_G=fg;J_B=fb
	End
	
	Method SetCol(fr#,fg#,fb#,fa#=-3717)
		J_R=fr;J_G=fg;J_B=fb
		If fa>-3717 Then J_A=fa
	End
	
	Method SetRot(fr#)
		J_Rot=-fr
	End
	Method Alpha(fa#)
		J_A=fa
	End

	Method Blend(fb)
		J_Blend=fb
	End
	

	Method SetSize(fx:Float,fy#=-3717)
		J_Scale_X=fx;J_Scale_Y=fx
		If fy>-3717 Then J_Scale_Y=fy
	End
	
	
	Method CLS2D(fr#=-3717,fg#=-1,fb#=-1,fa#=-1)
		J_ClipA=0;J_ClipB=0;J_ClipC=jscrw;J_ClipD=jscrh
		If fr>-3717
			J_CLS_R=fr
			J_CLS_G=fg
			J_CLS_B=fb
			J_CLS_A=fa
		Endif
		ResetDraw();
		'Cls()
		sprtup=0
	End

	Method Text(fx#,fy#,ftxt$,fc#=0,fcy#=0)
	ftxt=" "+ftxt
	Local fn,fl,fv:Int
	Local fw:Float
	Local fwt:Int
	fwt=0
	For fn=0 To ftxt.Length-2
			fv=ftxt[fn]-32;fw=0
			If fv=77 Or fv=87 Then fw=2
			If fv=45 Or fv=55 Then fw=1
			If fv=70 Or fv=73 Or fv=76 Then fw=-3
			If fv=83 Or fv=74 Or fv=75 Or fv=82 Or fv=84 Or fv=78 Or fv=90 Then fw=-1			
			fwt=fwt+(Float(imgd[J_Font*3]+fw)*J_Scale_X)
	Next
	
	fcy=fcy-1
	fx=fx+( (Sin((-J_Rot)-90)*(fwt)) *(fc/2))
	fy=fy-( (Cos((-J_Rot)-90)*(fwt)) *(fc/2))
	fx=fx+( (Sin((-J_Rot))*(imgd[J_Font*3+1]*J_Scale_Y)) *(fcy/2))
	fy=fy-( (Cos((-J_Rot))*(imgd[J_Font*3+1]*J_Scale_Y)) *(fcy/2))

	Local fsx#=fx
	Local fsy#=fy

#If TARGET="html5"
	J_R=255;J_G=255;J_B=255
#End

		For fn=0 To ftxt.Length-1
			fv=ftxt[fn]-32;fw=0
			If fv=77 Or fv=87 Then fw=2
			If fv=45 Or fv=55 Then fw=1
			If fv=70 Or fv=73 Or fv=76 Then fw=-3
			If fv=83 Or fv=74 Or fv=75 Or fv=82 Or fv=84 Or fv=78 Or fv=90 Then fw=-1			
			
			If ftxt[fn]=92 And ftxt[fn+1]=110
				fn=fn+1;fv=-32;fl=fl+1
				fx=fsx+(Sin((-J_Rot)+180)*((imgd[J_Font*3+1]+fw)*J_Scale_Y*fl))
				fy=fsy-(Cos((-J_Rot)+180)*((imgd[J_Font*3+1]+fw)*J_Scale_Y*fl))
			Endif
			If fv>0 And fv<128 Then DrawImg(J_Font,fx,fy,fv)
			If fv>-32
				fx=fx+(Sin((-J_Rot)+90)*((imgd[J_Font*3]+fw)*J_Scale_X))
				fy=fy-(Cos((-J_Rot)+90)*((imgd[J_Font*3]+fw)*J_Scale_X))
			Endif
		Next
		
	End

		
	Method DrawImg(fi,fx#,fy#,ff#=0)
		If sprtup<(MaxSprites-1)*15
			sprt[sprtup]=fi;sprt[sprtup+1]=fx;sprt[sprtup+2]=fy;sprt[sprtup+6]=ff
			sprt[sprtup+4]=J_Scale_X;sprt[sprtup+5]=J_Scale_Y;sprt[sprtup+3]=J_Rot
			sprt[sprtup+7]=J_A
			sprt[sprtup+10]=J_R;sprt[sprtup+11]=J_G;sprt[sprtup+12]=J_B
			sprt[sprtup+13]=J_Blend
'#If TARGET="html5"
'			sprt[sprtup+10]=255;sprt[sprtup+11]=255;sprt[sprtup+12]=255	
'#End
			sprtup=sprtup+15
		Endif
	End
	
	Method Rect(fx#,fy#,fw#,fh#)
		If sprtup<(MaxSprites-1)*15
			sprt[sprtup]=-3717;sprt[sprtup+1]=fx;sprt[sprtup+2]=fy;sprt[sprtup+6]=0
			sprt[sprtup+4]=fw;sprt[sprtup+5]=fh;sprt[sprtup+3]=J_Rot
			sprt[sprtup+7]=J_A
			sprt[sprtup+10]=J_R;sprt[sprtup+11]=J_G;sprt[sprtup+12]=J_B	
			sprt[sprtup+13]=J_Blend		
			sprtup=sprtup+15
		Endif		
	End
	Method Oval(fx#,fy#,fw#,fh#)
		If sprtup<(MaxSprites-1)*15
			sprt[sprtup]=-3716;sprt[sprtup+1]=fx;sprt[sprtup+2]=fy;sprt[sprtup+6]=0
			sprt[sprtup+4]=fw;sprt[sprtup+5]=fh;sprt[sprtup+3]=J_Rot
			sprt[sprtup+7]=J_A
			sprt[sprtup+10]=J_R;sprt[sprtup+11]=J_G;sprt[sprtup+12]=J_B
			sprt[sprtup+13]=J_Blend
			sprtup=sprtup+15
		Endif		
	End
	Method Line(fx#,fy#,fw#,fh#)
		If sprtup<(MaxSprites-1)*15
			sprt[sprtup]=-3715;sprt[sprtup+1]=fx;sprt[sprtup+2]=fy;sprt[sprtup+6]=0
			sprt[sprtup+4]=fw;sprt[sprtup+5]=fh;sprt[sprtup+3]=J_Rot
			sprt[sprtup+7]=J_A
			sprt[sprtup+10]=J_R;sprt[sprtup+11]=J_G;sprt[sprtup+12]=J_B
			sprt[sprtup+13]=J_Blend
			sprtup=sprtup+15
		Endif		
	End
	
	Method Button(fi,fx#,fy#,ff)
	Local fn
		DrawImg(fi,fx,fy,ff)
		o=0
		For fn=0 To 9
		If (tx[fn]>fx-((imgd[fi*3]*J_RetinaD)*J_Scale_X*.5) And tx[fn]<fx+((imgd[fi*3]*J_RetinaD)*J_Scale_X*.5) And ty[fn]>fy-((imgd[fi*3+1]*J_RetinaD)*J_Scale_Y*.5) And ty[fn]<fy+((imgd[fi*3+1]*J_RetinaD)*J_Scale_Y*.5) And mdAll>0)
			o=1
		End
		Next
		Return o
	End
	Method Button0(fi,fx#,fy#,ff)
	Local fn=0
		DrawImg(fi,fx,fy,ff)
		If (tx[fn]>fx-((imgd[fi*3]*J_RetinaD)*J_Scale_X*.5) And tx[fn]<fx+((imgd[fi*3]*J_RetinaD)*J_Scale_X*.5) And ty[fn]>fy-((imgd[fi*3+1]*J_RetinaD)*J_Scale_Y*.5) And ty[fn]<fy+((imgd[fi*3+1]*J_RetinaD)*J_Scale_Y*.5) And mdAll>0)
			Return 1
		End
		Return 0
	End
	
	' ***********  Load/Save
	
	Method Save()
		Local out$=""
		Local sum=0
		' Settings
		For n=0 To 24
			out=out+Set[n]+"|"
			sum=sum+Set[n]*n
		Next
		out=out+sum+"|";sum=0
		
		' Badges
		For w=0 To 7
		v=0
		For b=0 To 31
			v=v+(Badge[w*32+b] Shl b)
		Next
		out=out+v+"|"
		sum=sum+v
		Next
		out=out+sum+"|";sum=0
		
		' Highscores
		For g=0 To MaxGames-1
		For h=0 To MaxHigh-1
			out=out+High[(g*MaxHigh)+h]+"|"
			sum=sum+(High[(g*MaxHigh)+(h)]*(h+4))
			out=out+High[(g*MaxHigh)+h+(MaxGames*MaxHigh)]+"|"
			sum=sum+(High[(g*MaxHigh)+h+(MaxGames*MaxHigh)]*(g+h+3))
		Next
		out=out+sum+"|";sum=0
		Next
		
		If DebugMode=1 Then Print(out)
		
		SaveState(out)
	End
	
	Method Load()
		Local out$=LoadState()
		Local sum=0
		Local bits:=out.Split("|")
		c=0
		
		If DebugMode=1 Then Print(out)
		
		' Settings
		If bits.Length>24
			For n=0 To 24
'				Print(bits[n])
				Set[n]=Int(bits[n])
				sum=sum+Set[n]*n
			Next
			c=c+25
			v=Int(bits[c]);c=c+1
			If sum=v Then Print("Settings Loaded")
			If sum<>v
				Print("Settings Checksum Invalid")
				For n=0 To 24
					Set[n]=0
				Next
				Set[5]=1
			Endif
			v=0;sum=0
		Endif
		
		
		If Set[10]<64 Then Set[10]=64
		If Set[11]<64 Then Set[11]=64
		If Set[12]<8 Then Set[12]=10
		If Set[14]<1 Then Set[14]=64
		If isOuya=1 Then overscan=Set[14]
		If isOuya=0 Then Set[14]=1;overscan=0
		
		If bits.Length>c+8
			' Badges
			sum=0
			For w=0 To 7
				v=Int(bits[c+w])
				For b=0 To 31
					Badge[w*32+b]=Bool((v Shr b) & 1)
'					v=v+(Badge[w*32+b] Shl b)
				Next
				sum=sum+v
			Next
			c=c+8;
			v=Int(bits[c]);c=c+1
			If sum=v Then Print("Badges Loaded")
			If sum<>v
				Print("Badge Checksum Invalid")
				For b=0 To 255
					Badge[b]=False
				Next
			Endif
		Endif
		
		For g=0 To MaxGames-1
			If bits.Length>c+20
				sum=0
				For h=0 To MaxHigh-1
					High[(g*MaxHigh)+h]=Int(bits[c+(h*2)])
					sum=sum+(High[(g*MaxHigh)+h]*(h+4))
					High[(g*MaxHigh)+h+(MaxHigh*MaxGames)]=Int(bits[c+(h*2)+1])
					sum=sum+(High[(g*MaxHigh)+h+(MaxHigh*MaxGames)]*(g+h+3))					
				Next
				c=c+MaxHigh*2
				v=Int(bits[c]);c=c+1
				If sum=v Then Print("Highscore "+g+" Loaded")
				If sum<>v
					Print("Highscore "+g+" Checksum Invalid")
					For h=0 To MaxHigh-1
						High[(g*MaxHigh)+h]=0
						High[(g*MaxHigh)+h+(MaxHigh*MaxGames)]=0
					Next
				Endif
			Endif
		Next
	End
	
	
	' ******* BADGES!!
	
	Method BadgeName$(fn)
		Local out$=BadgeID(fn)
		Local bits:=out.Split("|")
		Return bits[0]
	End	
	Method BadgeDetail$(fn)
		Local out$=BadgeID(fn)
		Local bits:=out.Split("|")
		Return bits[1]
	End	
	
	
	Method GiveBadge(fn)
		If Badge[fn]=False
			Badge[fn]=True
			PlaySFX(95)
			f=0
			For b=0 To 12
				If BadgeTick[b]=0 And f=0 Then f=1;BadgeTick[b]=1;BadgeGet[b]=fn
			Next
		Endif
	End
	
	Method ShowBadges()
	ResetDraw()
	w=160
		For b=0 To 12
			If BadgeTick[b]>0
				BadgeTick[b]=BadgeTick[b]+1
				x=(-w)+BadgeTick[b]*16
				If BadgeTick[b]>240-(w/16) Then x=(-w)+((240-BadgeTick[b])*16)
				If x>0 Then x=0
						
				If BadgeTick[b]>240 Then BadgeTick[b]=0
				SetCol(0,0,80,0.8)
				Rect(x,jscrh-((b+1)*34),160,32)

				SetCol(255,255,255,1)
				Text(x+16,jscrh-((b+1)*34)+4,BadgeName(BadgeGet[b]),0,0)
				If BadgeGet[b]<64
					SetSize(0.5)
					DrawImg(80,x+(w-16),jscrh-((b+1)*34)+16,BadgeGet[b])
					SetSize(1)
				Endif
			Endif
		Next
	End
	
	' ****** Internetting
	
	Method GetURL(URL$,Data$="")
	URLData="N/A"
#If Not((LANG<>"cpp" And LANG<>"java" And TARGET<>"html5") Or TARGET="win8")
		get_req=New HttpRequest( "GET",URL+"?"+Data,Self )
		get_req.Send()
	Print("Requesting URL")
#Else
	Print("URL Access Unavailable for this Target")
#End
		GotURL=0
	End
	
	Method OnHttpRequestComplete:Void( req:HttpRequest )
	
		If req=get_req
			Print "Http GET complete! "+req.Status()
			GotURL=1
			URLData=req.ResponseText()
		Endif
		
'		Print "Status="+req.Status()
'		Print "ResponseText="+req.ResponseText()
	End
	
	
	
	' ******   GameCenter
	Method GC_Scoreboard(fn)
#If TARGET="ios"
		Paused=1
		If gamectr.GameCenterState()=2
			gamectr.ShowLeaderboard(LeaderBoard_ID+rstr(fn,2,"0"))
		Endif
#End
	End
	
	Method GC_PostScore(fn,fs)
#If TARGET="ios"
		If gamectr.GameCenterState()=2
			gamectr.ReportScore(fs,LeaderBoard_ID+rstr(fn,2,"0"))
		Endif
#End
	End
	
	Method GC_Badges()
	Local fn:Int;
#If TARGET="ios"
		If gamectr.GameCenterState()=2
			For fn=0 To 255
				If Badge[fn]=True And BadgeSent[fn]=False
					BadgeSent[fn]=True
					GC_PostBadge(fn,100)
				Endif
			Next
		Endif
#End
	End
	
	Method GC_PostBadge(fn,fp)
#If TARGET="ios"
		If gamectr.GameCenterState()=2
			gamectr.ReportAchievement((fp),Badge_ID+rstr(fn+1,3,"0") )
		Endif
#End
	End
	
	' ******   Core
	Method OnSuspend()
		iCade(0)
		If GameMode<10
			Paused=0;PausedMove=0;PausedIn=0
		Endif
		If GameMode>9	
			Paused=1
			PausedMove=1
			PausedIn=jscrh/2
		Endif
		SetUpdateRate 5
		Save()
	End

	Method OnResume()
		If GameMode<10
			Paused=0;PausedMove=0;PausedIn=0
		Endif
		If GameMode>9	
			Paused=1
			PausedMove=1
			PausedIn=jscrh/2
		Endif
		SetUpdateRate 60
		iCade(0)
		
#If TARGET="ios"
		gamectr=GameCenter.GetGameCenter()
		gamectr.StartGameCenter
#End

	End
	
	Method Touch(fx#,fy#,fw#,fh#)
		Rect(fx,fy,fw,fh)
		Local fo=0
		Local fn
		For fn=0 To 9
			If td[fn]
				If tx[fn]>fx-6 And ty[fn]>fy-6 And tx[fn]<fx+fw+12 And ty[fn]<fy+fh+12 Then fo=1
			Endif
		Next
		Return fo
	End

	Method MouseIn(fx#,fy#,fw#,fh#)
		Local fn,fo=0
		For fn=0 To 9
			If td[fn]
				If tx[fn]>fx And ty[fn]>fy And tx[fn]<fx+fw And ty[fn]<fy+fh Then fo=1
			Endif
		Next
		Return fo
	End

	Method MouseIn_Centered(fx#,fy#,fw#,fh#)
		Local fn,fo=0
		For fn=0 To 9
			If td[fn]
				If tx[fn]>fx-(fw*0.5) And ty[fn]>fy-(fh*0.5) And tx[fn]<fx+(fw*0.5) And ty[fn]<fy+(fh*0.5) Then fo=1
			Endif
		Next
		Return fo
	End


' Input Stuff / Joypad
	Method iCade(fn)
		If fn=1
			EnableKeyboard()
			iCadeControls=1
			Repeat
				a=GetChar()
			Until a=0
		Endif
		If fn=0
			DisableKeyboard()
			iCadeControls=0
			For n=0 To 18
				but[n]=0
			Next
		Endif
	End
	
	Method AnalogueControl()

ControlX=0;ControlY=0
	
	If mdAll=0 Then mcx=-1
	If mdAll>0
		If mcx>-1
			ControlX=Float(mx-mcx)/72
			ControlY=Float(my-mcy)/72
			If Abs(ControlX)<0.1 And Abs(ControlY)<0.1 Then ControlX=0;ControlY=0
			If mx<mcx-64 Then mcx=mcx-4
			If mx>mcx+64 Then mcx=mcx+4
			If my<mcy-64 Then mcy=mcy-4
			If my>mcy+64 Then mcy=mcy+4
		Endif
		If mcx<0
			mcx=mx;mcy=my
		Endif
		SetCol(0,100,250,0.25)
		Oval(mcx,mcy,12,12)
		Oval(mx,my,8,8)
	Endif

	If Abs(StickX())>0.2 Or Abs(StickY())>0.2 Then ControlX=StickX();ControlY=StickY()

	If PlayKey(0,0) Then ControlY2=ControlY2-0.15;ControlY=ControlY2
	If PlayKey(0,0)=0 And ControlY2<0
		ControlY2=ControlY2+0.2
		If ControlY2>0 Then ControlY2=0
		ControlY=ControlY2
	Endif
	If PlayKey(8,0) Then ControlY2=ControlY2+0.15;ControlY=ControlY2
	If PlayKey(8,0)=0 And ControlY2>0
		ControlY2=ControlY2-0.2
		If ControlY2<0 Then ControlY2=0
		ControlY=ControlY2
	Endif
	If PlayKey(3,0) Then ControlX2=ControlX2-0.15;ControlX=ControlX2
	If PlayKey(3,0)=0 And ControlX2<0
		ControlX2=ControlX2+0.2
		If ControlX2>0 Then ControlX2=0
		ControlX=ControlX2
	Endif
	
	If PlayKey(5,0) Then ControlX2=ControlX2+0.15;ControlX=ControlX2
	If PlayKey(5,0)=0 And ControlX2>0
		ControlX2=ControlX2-0.2
		If ControlX2<0 Then ControlX2=0
		ControlX=ControlX2
	Endif
	
	If ControlX<-1 Then ControlX=-1
	If ControlX>1 Then ControlX=1
	If ControlY<-1 Then ControlY=-1
	If ControlY>1 Then ControlY=1

	If ControlX2<-1 Then ControlX2=-1
	If ControlX2>1 Then ControlX2=1
	If ControlY2<-1 Then ControlY2=-1
	If ControlY2>1 Then ControlY2=1


	If (Abs(ControlX)>0.05 Or Abs(ControlY)>0.05) And DebugMode=1
		SetCol(0,180,250,0.5)
		Oval(jscrw-64,jscrh-64,12,12)
		Oval((jscrw-64)+(ControlX*52),(jscrh-64)+(ControlY*52),8,8)
	Endif

	
	End

	
	
	
	Method StickX#(fStick=0,fController=0)
	If fController>-1
		Return JoyX(fStick,fController)
	Endif
	End
	Method StickY#(fStick=0,fController=0)
	If fController>-1
#If TARGET<>"glfw"
		Return JoyY(fStick,fController)
#Endif
#If TARGET="glfw"
		If fStick=0 Then Return -JoyY(fStick,fController)
		If fStick<>0 Then Return JoyY(fStick,fController)
#Endif
	Endif
	End
	
	Method Trigger#(fTrigger=0,fController=0)
		If fController>-1 Then Return JoyZ(fTrigger,fController)
	End
	
	
	Method WhichController(ButNot=-1,ButNot2=-1,ButNot3=-1)
		Local ff=-1
		Local fm
		For fm=0 To 3
			If ButNot<>fm And ButNot2<>fm And ButNot3<>fm
				If (StickX(0,fm)<-0.4 Or StickX(0,fm)>0.4) And ff=-1 Then ff=fm
				If (StickY(0,fm)<-0.4 Or StickY(0,fm)>0.4) And ff=-1 Then ff=fm
				If (JoyDown(JOY_UP,fm) Or JoyDown(JOY_DOWN,fm)) And ff=-1 Then ff=fm
				If (JoyDown(JOY_LEFT,fm) Or JoyDown(JOY_RIGHT,fm)) And ff=-1 Then ff=fm
				If (JoyDown(JOY_A,fm) Or JoyDown(JOY_B,fm)) And ff=-1 Then ff=fm
				If (JoyDown(JOY_X,fm) Or JoyDown(JOY_Y,fm)) And ff=-1 Then ff=fm
				If (JoyDown(JOY_LB,fm) Or JoyDown(JOY_RB,fm)) And ff=-1 Then ff=fm
			Endif
		Next
		Return ff
	End
	

	
	
	Method PlayKey(fn,fAllowStick=1,fController=0)
	
If fController>-1	
	If iCadeControls=0
		Select fn
			Case 0
				Return KeyDown(KEY_UP) Or KeyDown(KEY_W) Or JoyDown(JOY_UP,fController) Or (StickY(0,fController)<-0.4 And fAllowStick=1) Or but[0]
			Case 3
				Return KeyDown(KEY_LEFT) Or KeyDown(KEY_A) Or JoyDown(JOY_LEFT,fController) Or (StickX(0,fController)<-0.4 And fAllowStick=1) Or but[3]
			Case 5
				Return KeyDown(KEY_RIGHT) Or KeyDown(KEY_D) Or JoyDown(JOY_RIGHT,fController) Or (StickX(0,fController)>0.4  And fAllowStick=1) Or but[5]
			Case 8
				Return KeyDown(KEY_DOWN) Or KeyDown(KEY_S) Or JoyDown(JOY_DOWN,fController) Or (StickY(0,fController)>0.4 And fAllowStick=1) Or but[8]
			Case 10
				Return KeyDown(KEY_Z) Or KeyDown(KEY_J) Or KeyDown(KEY_SPACE) Or KeyDown(KEY_ENTER) Or JoyDown(JOY_A,fController) Or but[10]
			Case 11
				Return KeyDown(KEY_X) Or KeyDown(KEY_K) Or KeyDown(KEY_CONTROL) Or JoyDown(JOY_B,fController) Or but[11]
			Case 12
				Return KeyDown(KEY_C) Or KeyDown(KEY_L) Or KeyDown(KEY_SHIFT) Or JoyDown(JOY_X,fController) Or but[12]
			Case 13
				Return KeyDown(KEY_V) Or KeyDown(KEY_I) Or JoyDown(JOY_Y,fController) Or but[13]
			Case 14
				Return KeyDown(KEY_B) Or KeyDown(KEY_U) Or JoyDown(JOY_LB,fController) Or but[14]
			Case 15
				Return KeyDown(KEY_N) Or KeyDown(KEY_O) Or JoyDown(JOY_RB,fController) Or but[15]
				
			Case 99
				If isOuya=0 Then Return KeyDown(KEY_ESCAPE) Or KeyDown(KEY_TILDE) Or KeyDown(KEY_DELETE) Or KeyDown(KEY_BACKSPACE) Or JoyDown(JOY_BACK,fController) Or JoyDown(JOY_START,fController) Or JoyDown(JOY_MENU,fController) Or but[16] Or but[17] Or but[19]
				If isOuya=1 Then Return but[19]
		End
	End
	
	If iCadeControls=1
		Select fn
			Case 0
				Return KeyDown(KEY_UP) Or JoyDown(JOY_UP,fController) Or but[0]
			Case 3
				Return KeyDown(KEY_LEFT) Or JoyDown(JOY_LEFT,fController) Or but[3]
			Case 5
				Return KeyDown(KEY_RIGHT) Or JoyDown(JOY_RIGHT,fController) Or but[5]
			Case 8
				Return KeyDown(KEY_DOWN) Or JoyDown(JOY_DOWN,fController) Or but[8]
			Case 10
				Return KeyDown(KEY_SPACE) Or KeyDown(KEY_ENTER) Or JoyDown(JOY_A,fController) Or but[10]
			Case 11
				Return KeyDown(KEY_CONTROL) Or JoyDown(JOY_B,fController) Or but[11]
			Case 12
				Return KeyDown(KEY_SHIFT) Or JoyDown(JOY_X,fController) Or but[12]
			Case 13
				Return JoyDown(JOY_Y,fController) Or but[13]
			Case 14
				Return JoyDown(JOY_LB,fController) Or but[14]
			Case 15
				Return JoyDown(JOY_RB,fController) Or but[15]

			Case 99
				Return KeyDown(KEY_ESCAPE) Or KeyDown(KEY_DELETE) Or KeyDown(KEY_BACKSPACE) Or JoyDown(JOY_START,fController) Or JoyDown(JOY_BACK,fController) Or JoyDown(JOY_MENU,fController) Or but[16] Or but[17] Or but[19]
				
		End Select
		
	Endif
Endif



If fController=-1
	If iCadeControls=0
		Select fn
			Case 0
				Return KeyDown(KEY_UP) Or KeyDown(KEY_W) Or but[0]
			Case 3
				Return KeyDown(KEY_LEFT) Or KeyDown(KEY_A) Or but[3]
			Case 5
				Return KeyDown(KEY_RIGHT) Or KeyDown(KEY_D) Or but[5]
			Case 8
				Return KeyDown(KEY_DOWN) Or KeyDown(KEY_S) Or but[8]
			Case 10
				Return KeyDown(KEY_Z) Or KeyDown(KEY_J) Or KeyDown(KEY_SPACE) Or KeyDown(KEY_ENTER) Or but[10]
			Case 11
				Return KeyDown(KEY_X) Or KeyDown(KEY_K) Or KeyDown(KEY_CONTROL) Or but[11]
			Case 12
				Return KeyDown(KEY_C) Or KeyDown(KEY_L) Or KeyDown(KEY_SHIFT) Or but[12]
			Case 13
				Return KeyDown(KEY_V) Or KeyDown(KEY_I) Or but[13]
			Case 14
				Return KeyDown(KEY_B) Or KeyDown(KEY_U) Or but[14]
			Case 15
				Return KeyDown(KEY_N) Or KeyDown(KEY_O) Or but[15]
				
			Case 99
				If isOuya=0 Then Return KeyDown(KEY_ESCAPE) Or KeyDown(KEY_TILDE) Or KeyDown(KEY_DELETE) Or KeyDown(KEY_BACKSPACE) Or but[16] Or but[17] Or but[19]
				If isOuya=1 Then Return but[19]
		End
	End
	
	If iCadeControls=1
		Select fn
			Case 0
				Return KeyDown(KEY_UP) Or but[0]
			Case 3
				Return KeyDown(KEY_LEFT) Or but[3]
			Case 5
				Return KeyDown(KEY_RIGHT) Or but[5]
			Case 8
				Return KeyDown(KEY_DOWN) Or but[8]
			Case 10
				Return KeyDown(KEY_SPACE) Or KeyDown(KEY_ENTER) Or but[10]
			Case 11
				Return KeyDown(KEY_CONTROL) Or but[11]
			Case 12
				Return KeyDown(KEY_SHIFT) Or but[12]
			Case 13
				Return but[13]
			Case 14
				Return but[14]
			Case 15
				Return but[15]

			Case 99
				Return KeyDown(KEY_ESCAPE) Or KeyDown(KEY_DELETE) Or KeyDown(KEY_BACKSPACE) Or but[16] Or but[17] Or but[19]
				
		End Select
		
	Endif
Endif
	
	End

	Method PlayKeyAll(fn,fAllowStick=1)
		Local fstick,fout=0
		For fstick=0 To 3
			fout=fout+PlayKey(fn,fAllowStick,fstick)
		Next
		Return fout
	End



	Method PauseMenu()
		
		ResetDraw()
		SetCol(0,0,0,((Abs(PausedIn))/(jscrh*.8)))
		Rect(0,0,jscrw,jscrh)
		
		If PausedMove=1 And PausedIn<jscrh/2 Then PausedIn=PausedIn+24
		If PausedMove=-1 And PausedIn>-64 Then PausedIn=PausedIn-24
		If PausedMove=-1 And PausedIn<-32 Then Paused=0
		ResetDraw()
		
		If Orientation=1	'1=Landscape
			SetCol(255,255,10,0.6)
			Rect(jscrw/2-128,PausedIn-64,256,8)
			SetCol(255,150,10,0.7)
			Rect(jscrw/2-140,PausedIn-52,280,104)
			SetCol(10,150,255,0.6)
			Rect(jscrw/2-128,PausedIn+56,256,8)
		Endif
		
		If Orientation=0 	'0=Portrait
			SetCol(255,255,10,0.6)
			Rect(jscrw/2-96,PausedIn-92,192,8)
			SetCol(255,150,10,0.7)
			Rect(jscrw/2-128,PausedIn-80,256,160)
			SetCol(10,150,255,0.6)
			Rect(jscrw/2-96,PausedIn+84,192,8)
		Endif
		
		If isOuya=1
			ResetDraw()
			SetSize(2)
			Text(jscrw/2,PausedIn-150,"L1 <      Overscan      > R1",1,1)
			SetCol(0,128,255,0.5)
			SetSize(1)
			Rect(jscrw/2-128,PausedIn-154,256,9)
			SetCol(255,255,0,0.75)
			Rect(jscrw/2-132+Set[14]*2.67,PausedIn-158,8,16)
			If MouseIn_Centered(jscrw/2,PausedIn-158,256,16) And mdis=0
				mdis=1;PlaySFX(98);
				If overscan>1 Then Set[14]=1
				If overscan<32 Then Set[14]=96
			Endif

			If PlayKeyAll(14) And kdis=0 And Set[14]>0 Then Set[14]=Set[14]-16;kdis=1
			If PlayKeyAll(15) And kdis=0 And Set[14]<96 Then Set[14]=Set[14]+16;kdis=1
			If Set[14]<1 Then Set[14]=1
			If Set[14]>96 Then Set[14]=96

			overscan=Set[14]

		Endif
		
				
		' ** Play
		SetSize(2)
		SetCol(50,50,250,1)
		If Button(97,jscrw/2,PausedIn,3) And mdis=0
			Paused=1;PausedMove=-1;mdis=1;PlaySFX(98,1,0.5)
		Endif
		If PausedMenu=0
			SetSize(2.5)
			SetCol(255,255,100,1)
			DrawImg(97,jscrw/2,PausedIn,6)
			If PlayKeyAll(10) And kdis=0 Then Paused=1;PausedMove=-1;kdis=1;PlaySFX(98,1,0.5)
			If (PlayKeyAll(3) Or PlayKeyAll(0)) And kdis=0 Then PausedMenu=-1;kdis=1;PlaySFX(98,0.8,0.5)
			If (PlayKeyAll(5)) And kdis=0 Then PausedMenu=1;kdis=1	;PlaySFX(98,1.2,0.5)
		Endif
		
		SetSize(2)
		' ** Quit
		SetCol(255,50,50,1)
		x=jscrw/2-140;y=PausedIn-64
		If Orientation=0 Then x=jscrw/2-96;y=PausedIn-96
		If Button(97,x,y,1) And mdis=0
			Paused=0;PausedMove=-1;PausedIn=-64;EndofGame=1;mdis=1;PlaySFX(98,0.5,0.5)
		Endif
		If PausedMenu=-1
			SetSize(2.5)
			SetCol(255,255,100,1)
			DrawImg(97,x,y,6)
			If PlayKeyAll(10) And kdis=0 Then Paused=0;PausedMove=-1;PausedIn=-64;EndofGame=1;mdis=1;kdis=1;PlaySFX(98,0.5,0.5)
			If (PlayKeyAll(5) Or PlayKeyAll(8)) And kdis=0 Then PausedMenu=0;kdis=1;PlaySFX(98,0.8,0.5)
		Endif
		
		' ** Options
		SetSize(1)
		SetCol(255,255,255,1)
'		s=4;If Set[5]=0 Then s=5
		x=jscrw/2+140;y=PausedIn-64
		If Orientation=0 Then x=jscrw/2+96;y=PausedIn-96
		
	If OptionsOn=0 Then CogSpin=CogSpin+0.2
	SetRot(0-CogSpin*0.66)
	DrawImg(95,x,y,8)
	SetRot((CogSpin*0.33))
	DrawImg(95,x,y,9)

		If Button(95,x,y,10) And mdis=0
			OptionsOn=1;mdis=1;PlaySFX(99)
		Endif
'		If Set[5]>0 And Set[5]<4 And HasMusic=1
'			SetSize(1.5)
'			SetCol(180,255,255,1)
'			DrawImg(97,x+20,y,Set[5]+7)
'		Endif
		If PausedMenu=1
			SetSize(2.5)
			SetCol(255,255,100,1)
			DrawImg(97,x,y,6)
			If PlayKeyAll(10) And kdis=0 Then OptionsOn=1;kdis=1;PlaySFX(98,1,0.5)
			If (PlayKeyAll(3) Or PlayKeyAll(8)) And kdis=0 Then PausedMenu=0;kdis=1;PlaySFX(98,0.8,0.5)
		Endif

		If PlayKeyAll(99) And kdis=0 Then kdis=1;Paused=1;PausedMove=-1;PlaySFX(98,1,0.5)
	End
	

	Method InGame()
		ResetDraw()
		MenuIn=-32
		
		If (PlayKeyAll(99) Or (PlayKeyAll(13) And isOuya=1)) And Paused=0 And kdis=0 Then kdis=1; Paused=1;PausedMove=1;PausedMenu=0;;PlaySFX(98,1,0.5)
If ScreenshotMode=0		
		If Button(97,16,16,0) And Paused=0
			Paused=1;PausedMove=1;mdis=1;PausedMenu=0;PlaySFX(98,1,0.5)
		Endif
Endif
		If Paused=1 Then PauseMenu()
	End
	
	
	Method WaitStart(fn=0)
		CLS2D(40,40,80,1)
		u=jscrw
		If jscrh<jscrw Then u=jscrh
		wr=wr+16
If fn=1
		For n=0 To 10
			SetCol(250,250,250,Float(n)/10)
			Oval((jscrw*.5)+(Sin((wr+180)+(n*16))*u*.25),(jscrh*.5)-(Cos((wr+180)+(n*16))*u*.25),8,8)
		Next
Endif

		SetCol(255,255,0,0.8)
		Oval(jscrw*.5,jscrh*.5,u*.3,u*.3)
		SetCol(250,160,60,0.7)
		Rect(0,jscrh*.4,jscrw,jscrh*.2)

		ResetDraw();
		DrawImg(93,jscrw*.5,jscrh*.48,0)
If fn=1
		For n=0 To 10
			SetCol(50,50,50,Float(n)/10)
			Oval((jscrw*.5)+(Sin(wr+(n*16))*u*.25),(jscrh*.5)-(Cos(wr+(n*16))*u*.25),8,8)
		Next
Endif

If fn=0
SetSize(1)
	SetCol(0,0,0,0.2)
	Oval(jscrw*0.5,jscrh*0.7,128+8,16+8)
	Oval(jscrw*0.5,jscrh*0.7,128+4,16+4)
	Oval(jscrw*0.5,jscrh*0.7,128,16)
	
SetSize(2)
	SetCol(255,255,255,1)
	Text(jscrw*0.5,jscrh*0.7,"Click to Start",1,1)	
Endif
		If fn=0 And (mdAll2>0) And mx>jscrw*.25 And my>jscrh*.25 And mx<jscrw*.75 And my<jscrh*.75
			mdis=1
			GameMode=1
			Reload()
			SetUpdateRate 60
		Endif
	End

	Method OnUpdate()

		If isOuya=0 Then but[19]=KeyHit(KEY_BACK)
		If isOuya=1 Then but[19]=(JoyHit(JOY_MENU)>0)

		If KeyHit(KEY_F1) Then DebugMode=1-DebugMode			' Debugmode mode adds framerate to bottom left, and a few other bits and pieces.
		If KeyHit(KEY_F2) Then ScreenshotMode=1-ScreenshotMode 	' Screenshot mode removes the top-left close button, and any GUI elements you've set to be disabled

		If KeyHit(KEY_F11) Then FullscreenFlip()
		
#If TARGET="glfw"
	If KeyHit(KEY_F4) Then Error ""
#End

		If KeyHit( KEY_CLOSE ) Then Error "" ' exit app when 'X' button clicked :)
		UpdateAsyncEvents	' Keep Background Net-Based stuff ticking away

If HasMusicStream=1
	If Paused<>0 And J_MusicPlaying=1 Then PauseMusic()
	If Paused=0 And J_MusicPlaying=1 Then ResumeMusic()	
Endif



		If (Millisecs()-lmsu)>0 Then fpsu=1000/(Millisecs()-lmsu)
		fpsua=((fpsua*9)+fpsu)/10
		lmsu=Millisecs()

		If HasMusic=1 Then MusicPlayer.JM_Alive_U(Paused,(Set[5]=1 Or Set[5]=3))

		mwx=mx;mwy=my
		Local o2#=overscan*(Float(DeviceHeight)/Float(DeviceWidth()))
		mx=(MouseX()-overscan)/scaleX
		my=(MouseY()-o2)/scaleY
		If md=0 And MouseDown() Then mwx=mx;mwy=my
		mdAll=MouseDown()
		mdAll2=MouseHit()
		For n=0 To 9
			td[n]=0;tx[n]=-3717;ty[n]=-3717
			If TouchDown(n)
				td[n]=1;tx[n]=(TouchX(n)-overscan)/scaleX;ty[n]=(TouchY(n)-o2)/scaleY
				mdAll=1
			Endif
		Next
		
		md=MouseDown()
		If mdAll=0 Then mdis=0
		If mdel>0 Then mdel=mdel-1

		If Not PlayKeyAll(0) And Not PlayKeyAll(3) And Not PlayKeyAll(5) And Not PlayKeyAll(8) And Not PlayKeyAll(10) And Not PlayKeyAll(11) And Not PlayKeyAll(12) And Not PlayKeyAll(13) And Not PlayKeyAll(14) And Not PlayKeyAll(15) And Not PlayKeyAll(16) And Not PlayKeyAll(17) And Not PlayKeyAll(99) Then kdis=0
	If kdis=0 And mdis=0 And PlayKeyAll(99) And GameMode=1
		If CreditsOn=1 Or OptionsOn=1 Or BadgesOn=1 Then CreditsOn=0;BadgesOn=0;kdis=1;mdis=1
	Endif
	
		If OptionsOn=1 Then kdis=1;mdis=1

		If J_Loader=0
		Select GameMode
			Case 1
				Menu()
			Case 2
				LoadMenu()
				PlaySFX(SFX_Jingle)
				GameMode=1
			Case 4
				OuyaQuit()
				
			Case 5
				WaitStart()
			
			Case 10
				Game()
				InGame()
				
			Case 11
				LoadGame()

		End Select
		
	If GameMode=10 And EndofGame>0 Then GameOver()
	If GameMode=1 Or GameMode=2 Then GameOver()
	
	If GameMode=1 And (CreditsOn=1 Or CreditsIn>0) Then CreditBox()
	If CreditsOn=0 And CreditsIn>0 Then CreditsIn=CreditsIn-1
	If CreditsOn=1 And CreditsIn<30 Then CreditsIn=CreditsIn+1
	
	If GameMode=1 And BadgesOn=1 Then BadgesBox()
	
	If (OptionsOn=1 Or OptionsIn>0) Then OptionBox()
	If OptionsOn=0 And OptionsIn>0 Then OptionsIn=OptionsIn-1
	If OptionsOn=1 And OptionsIn<30 Then OptionsIn=OptionsIn+1
	
	
	
	
		Endif
		
		If J_Loader>0 Then Loader()

#Rem
	iCade
	
	Up		W	E
	Down	X	Z
	Left	A	Q
	Right	D	C
	
	1		Y	T
	2		U	F
	3		I	M
	4		O	G
	5		H	R
	6		J	N
	7		K	P
	8		L	V
#End

If iCadeControls=1
	Repeat
		a=GetChar()
		If a>0
		Select String.FromChar(a)
			Case "W","w"	but[0]=2
			Case "E","e"	but[0]=0

			Case "X","x"	but[8]=2
			Case "Z","z"	but[8]=0

			Case "A","a"	but[3]=2
			Case "Q","q"	but[3]=0

			Case "D","d"	but[5]=2
			Case "C","c"	but[5]=0


			Case "Y","y"	but[13]=2
			Case "T","t"	but[13]=0

			Case "U","u"	but[14]=2
			Case "F","f"	but[14]=0

			Case "I","i"	but[15]=2
			Case "M","m"	but[15]=0

			Case "O","o"	but[16]=2
			Case "G","g"	but[16]=0


			Case "H","h"	but[10]=2
			Case "R","r"	but[10]=0
			
			Case "J","j"	but[11]=2
			Case "N","n"	but[11]=0

			Case "K","k"	but[12]=2
			Case "P","p"	but[12]=0

			Case "L","l"	but[17]=2
			Case "V","v"	but[17]=0
			
		End Select
		Endif
	Until a=0
	
Endif

		For n=0 To 18
			If but[n]=1 Then but[n]=0
		Next

		If OnScreenControls=1 And GameMode>5 And iCadeControls=0
			If Set[10]<32 Then Set[10]=32
			If Set[10]>jscrw-32 Then Set[10]=jscrw-32
			If Set[11]<32 Then Set[11]=32
			If Set[11]>jscrh-32 Then Set[11]=jscrh-32
			If Set[12]<8 Then Set[12]=8
			If Set[12]>25 Then Set[12]=25
		
			DPadX=Set[10]
			DPadY=jscrh-Set[11]
			DPadZ=Float(Set[12])/10
			ResetDraw();SetCol(255,255,255,0.6)
			SetSize(DPadZ)
			If Button(94,(DPadX)-(32*DPadZ),DPadY,4) And Paused=0 Then but[3]=1
			If Button(94,(DPadX),DPadY-(32*DPadZ),1) And Paused=0 Then but[0]=1
			If Button(94,(DPadX),DPadY+(32*DPadZ),9) And Paused=0 Then but[8]=1
			If Button(94,(DPadX)+(32*DPadZ),DPadY,6) And Paused=0 Then but[5]=1
			DrawImg(94,(DPadX),DPadY,5)
			If Paused>0
				SetSize(3)
				If Button0(94,(DPadX),DPadY,0) And td[1]=0
					Set[10]=tx[0]
					Set[11]=jscrh-ty[0]
				Endif
				If td[1]=0 Then e=0;f=0
				If td[0] And td[1]
					d=tx[0]-tx[1]
					If tx[1]<tx[0] Then d=tx[1]-tx[0]
					d=d/16
						If e=1
							Set[12]=Set[12]-(d-f)
						Endif
					f=d
					e=1
				Endif
			Endif

			SetSize(1.5*DPadZ)
			If Button(94,jscrw-((DPadX)-(24*DPadZ)),DPadY-(24*DPadZ),0) Then but[10]=1
			If Button(94,jscrw-((DPadX)+(24*DPadZ)),DPadY+(24*DPadZ),0) Then but[11]=1
		Endif

		If AccelerometerControls=1 And iCadeControls=0
			ResetDraw()
			SetSize(1.5)
			SetCol(255,255,255,0.8)
			J_AX=-(J_AX_Level-AccelX())
			J_AY=-(J_AY_Level-AccelY())
			
			J_AXU=J_AXU-((J_AXU-J_AX)/4)
			J_AYU=J_AYU-((J_AYU-J_AY)/4)
			If Abs(J_AXU-J_AX)<0.005 Then J_AXU=J_AX
			If Abs(J_AYU-J_AY)<0.005 Then J_AYU=J_AY
			
			
			If Button(97,24,jscrh-24,7)
				J_AX_Level=AccelX()
				J_AY_Level=AccelY()
			Endif
						
			SetCol(100,255,100,0.6)
			SetSize(1)
			Oval(24+(J_AXU*20),(jscrh-24)+(J_AYU*20),4,4)
		Endif
			
			If iCadeControls=1 ' disable Accelerometer!
				J_AX=0;J_AXU=0
				J_AY=0;J_AYU=0
			Endif

		If DebugMode=1 And GameMode<>5
			ResetDraw()
			If AccelerometerControls=1 And iCadeControls=0 Then Text 16,jscrh*.5,fpsra+":"+scaleX+","+scaleY
			If AccelerometerControls=0 Or iCadeControls=1 Then Text 16,jscrh-16,fpsra+":"+scaleX+","+scaleY
		Endif
		
		ShowBadges()
 	End


	Method OptionBox()
		ResetDraw()

If isOuya=1
	Rect(0,0,16,8)
	Rect(0,0,8,16)
	
	Rect(0,jscrh-8,16,8)
	Rect(0,jscrh-16,8,16)
	
	Rect(jscrw-16,0,16,8)
	Rect(jscrw-8,0,8,16)
	
	Rect(jscrw-16,jscrh-8,16,8)	
	Rect(jscrw-8,jscrh-16,8,16)
Endif


kdis=1;mdis=1
If OptionsIn<>30 Then Okdis=1;Omdis=1

	SetCol(150,75,0,0.85)
	Rect(50,0+((30-OptionsIn)*24),jscrw-100,(jscrh))

	SetCol(255,255,255,1)


	CogSpin=CogSpin+0.2
	
	SetSize(1.5)
	If OptionsSelect=0 Then SetSize(2)
	x=100-((30-OptionsIn)*12);y=60
	SetRot(0-CogSpin*0.66)
	DrawImg(95,x,y,8)
	SetRot((CogSpin*0.33))
	DrawImg(95,x,y,9)
	s=10
	SetRot(CogSpin)
	a=Button(95,x,y,s)
	If PlayKeyAll(99) Then a=1
	If a And Omdis=0 And Okdis=0 Then OptionsOn=0;PlaySFX(99);Save()
	ResetDraw()
	SetSize(2)
	Text(x+76,y,"<[BACK]",0,1)


' -=-=-=-=-= Overscan Option
		If isOuya=1
		y=92-((30-OptionsIn)*12)
			ResetDraw()
			SetSize(2)
			Text(jscrw*0.6,y,"L1 <      Overscan      > R1",1,1)
			SetCol(0,128,255,0.5)
			SetSize(1)
			Rect((jscrw*0.6)-128,y-5,256,9)
			SetCol(255,255,0,0.75)
			Rect((jscrw*0.6)-132+Set[14]*2.67,y-8,8,16)
			If MouseIn_Centered((jscrw*0.6),y-8,256,16) And mdis=0
				mdis=1;PlaySFX(98);
				If overscan>1 Then Set[14]=1
				If overscan<32 Then Set[14]=96
			Endif

			If PlayKeyAll(14) And Okdis=0 Then Set[14]=Set[14]-16;Okdis=1
			If PlayKeyAll(15) And Okdis=0 Then Set[14]=Set[14]+16;Okdis=1
			If Set[14]<1 Then Set[14]=1
			If Set[14]>96 Then Set[14]=96

			overscan=Set[14]
		Endif




' -=-=-=-=-= Sound Option
o=1
x=100;y=130+((30-OptionsIn)*24)

SetCol(0,0,160,0.5);If OptionsSelect=o Then SetCol(0,180,255,0.5)
a=Touch(x-16,y-2,jscrw-((x-16)*2),24)
If a=1 Then OptionsSelect=o
If OptionsSelect=o And (PlayKeyAll(10) Or PlayKeyAll(11) Or PlayKeyAll(12) Or PlayKeyAll(13) Or PlayKeyAll(14) Or PlayKeyAll(15)) Then a=1
SetCol(255,255,255,1)
SetSize(2)
If HasMusic=0 And HasMusicStream=0
	If Set[5]=0 Then Text(x,y,"Sound : Off")
	If Set[5]=1 Then Text(x,y,"Sound : On")
	If Set[5]<0 Or Set[5]>1 Then Set[5]=0
Endif
If HasMusic=1 Or HasMusicStream=1
	If Set[5]=0 Then Text(x,y,"Sound : Off")
	If Set[5]=1 Then Text(x,y,"Sound : SFX + Music")
	If Set[5]=2 Then Text(x,y,"Sound : SFX")
	If Set[5]=3 Then Text(x,y,"Sound : Music")
	If Set[5]<0 Or Set[5]>3 Then Set[5]=0
Endif

If a And Okdis=0 And Omdis=0
			If HasMusic=1 Or HasMusicStream=1
				Set[5]=(Set[5]+1) Mod 4;
				If Set[5]=2 Or Set[5]=0 Then StopTune()
			Endif
			If HasMusic=0 And HasMusicStream=0
				Set[5]=1-Set[5]
				If Set[5]<0 Or Set[5]>1 Then Set[5]=0
			Endif
			Okdis=1;Omdis=1;PlaySFX(99)
Endif
' -=-=-=-=-=-=


If iCadeAllowed=1 And isOuya=0
' -=-=-=-=-= iCade Option
o=o+1
x=100;y=y+40

SetCol(0,0,160,0.5);If OptionsSelect=o Then SetCol(0,180,255,0.5)
a=Touch(x-16,y-2,jscrw-((x-16)*2),24)
If a=1 Then OptionsSelect=o
If OptionsSelect=o And (PlayKeyAll(10) Or PlayKeyAll(11) Or PlayKeyAll(12) Or PlayKeyAll(13) Or PlayKeyAll(14) Or PlayKeyAll(15)) Then a=1
SetCol(255,255,255,1)
SetSize(2)
If iCadeControls=0 Then Text(x,y,"iCade : Off")
If iCadeControls=1 Then Text(x,y,"iCade : On")
 
If a And Omdis=0
	iCadeControls=1-iCadeControls
	iCade(iCadeControls)
	Okdis=1;Omdis=1;PlaySFX(99)
	For n=0 To 19
	but[n]=0
	Next
Endif
' -=-=-=-=-=-=
Endif




' =-=-=-=-=-=-=-=  Fullscreen Option : HTML
#If TARGET="html5"
Local bigwide=0
Local bighigh=0
Local br,bg,bb

o=o+1
x=100;y=y+40

SetCol(0,0,160,0.5);If OptionsSelect=o Then SetCol(0,180,255,0.5)
a=Touch(x-16,y-2,jscrw-((x-16)*2),24)
If a=1 Then OptionsSelect=o
If OptionsSelect=o And (PlayKeyAll(10) Or PlayKeyAll(11) Or PlayKeyAll(12) Or PlayKeyAll(13) Or PlayKeyAll(14) Or PlayKeyAll(15)) Then a=1
SetCol(255,255,255,1)
SetSize(2)
Text(x,y,"Fullscreen")

If a And Omdis=0 And Okdis=0
	Okdis=1;Omdis=1;PlaySFX(99)
	FullscreenFlip()
Endif

#Endif
'=-=--=-=-=-=--=-=-=-




' =-=-=-=-=-=-=-=  Fullscreen Option : GLFW
#If TARGET="glfw"
o=o+1
x=100;y=y+40

SetCol(0,0,160,0.5);If OptionsSelect=o Then SetCol(0,180,255,0.5)
a=Touch(x-16,y-2,jscrw-((x-16)*2),24)
If a=1 Then OptionsSelect=o
If OptionsSelect=o And (PlayKeyAll(10) Or PlayKeyAll(11) Or PlayKeyAll(12) Or PlayKeyAll(13) Or PlayKeyAll(14) Or PlayKeyAll(15)) Then a=1
SetCol(255,255,255,1)
SetSize(2)
If J_Fullscreen=0 Then Text(x,y,"Fullscreen")
If J_Fullscreen=1 Then Text(x,y,"Windowed")

If a And Omdis=0
	Okdis=1;Omdis=1;PlaySFX(99)
	FullscreenFlip()
Endif


#Endif
'=-=--=-=-=-=--=-=-=-



' -=-=-=-=-= Credits Button
If Paused=0
o=o+1
x=jscrw-264;y=y+50

SetCol(0,0,160,0.5);If OptionsSelect=o Then SetCol(0,180,255,0.5)
a=Touch(x-16,y-2,180,24)
If a=1 Then OptionsSelect=o
If OptionsSelect=o And (PlayKeyAll(10) Or PlayKeyAll(11) Or PlayKeyAll(12) Or PlayKeyAll(13) Or PlayKeyAll(14) Or PlayKeyAll(15)) Then a=1
SetCol(255,255,255,1)
SetSize(2)
Text(x,y,"Credits")
 
If a And Okdis=0 And Omdis=0
	CreditsOn=1;Okdis=0;Omdis=0;OptionsOn=0
Endif
Endif
' -=-=-=-=-=-=

	
		
		If Okdis=0 And (PlayKeyAll(15) Or PlayKeyAll(10) Or PlayKeyAll(11)) And OptionsSelect=0 Then Okdis=1;OptionsOn=0;PlaySFX(99);Save()
		
		
		If Okdis=0 And (PlayKeyAll(0) Or PlayKeyAll(3)) And OptionsSelect>0 Then OptionsSelect=OptionsSelect-1;Okdis=1;PlaySFX(99)
		If Okdis=0 And (PlayKeyAll(8) Or PlayKeyAll(5)) And OptionsSelect<o Then OptionsSelect=OptionsSelect+1;Okdis=1;PlaySFX(99)
		
		
		
		If mdAll=0 Then Omdis=0
		If Not PlayKeyAll(0) And Not PlayKeyAll(3) And Not PlayKeyAll(5) And Not PlayKeyAll(8) And Not PlayKeyAll(10) And Not PlayKeyAll(11) And Not PlayKeyAll(12) And Not PlayKeyAll(13) And Not PlayKeyAll(14) And Not PlayKeyAll(15) And Not PlayKeyAll(16) And Not PlayKeyAll(17) And Not PlayKeyAll(99) Then Okdis=0
		
		ResetDraw()
	End

	Method FullscreenFlip()
#If TARGET="glfw"
Local bigwide=0
Local bighigh=0
Local br,bg,bb
Local mode:GlfwVideoMode=GlfwGame.GetGlfwGame().GetGlfwDesktopMode()
bigwide=mode.Width
bighigh=mode.Height
br=mode.RedBits
bg=mode.GreenBits
bb=mode.BlueBits

		J_Fullscreen=1-J_Fullscreen
		If J_Fullscreen=1
			GlfwGame.GetGlfwGame().SetGlfwWindow(bigwide,bighigh,br,bg,bb,0,0,0,True)
		Endif
		If J_Fullscreen=0
			GlfwGame.GetGlfwGame().SetGlfwWindow(640,480,br,bg,bb,0,0,0,False)		
		Endif
#End


#If TARGET="html5"
	GoFullscreen
#End
	End


	Method OuyaQuit()
		CLS2D(180,180,180)
		SetSize(3)
		DrawImg(91,jscrw/2,jscrh/2,0)
		
		SetSize(2)
		x=jscrw*0.65
		y=jscrh*0.3
		SetSize(3)
		Text(x,y,"It looks like you're",1,1);y=y+32
		Text(x,y,"trying to QUIT!",1,1);y=y+36

		SetSize(2)
		Text(x,y,"Are you absolutely sure",1,1);y=y+20
		Text(x,y,"you want to quit the game?",1,1);y=y+28
		Text(x,y,"Isn't this fun?",1,1);y=y+20
y=y+18
		Text(x,y,"It'll be a shame to see you go.",1,1);y=y+20
y=y+18
		Text(x,y,"Press (A) to Quit",1,1);y=y+20
		Text(x,y,"or (O) to return to the fun!",1,1);y=y+20
		
If mdis=0 And kdis=0
		If PlayKeyAll(10) Then GameMode=1;kdis=1;mdis=1
		If PlayKeyAll(11) Or PlayKeyAll(12) Or PlayKeyAll(99) Then Error("")
Endif

	End


	Method CreditBox()
		ResetDraw()
		credx=9;credy=9

		Local gw#,gh#,gz#
		
		gw=jscrw/12
		gh=jscrh/12
		If gh>gw Then gw=gh
		If gw>gh Then gh=gw
		Local cx#,cy#,dx#,dy#
		credx=jscrw/gw
		credy=jscrh/gh
		
		cx=(jscrw/2)-((gw*credx)*0.5)
		cy=(jscrh/2)-((gh*credy)*0.5)
		
		p=30-CreditsIn
		Alpha(Float(CreditsIn)/30)

		gz=gw		
		If CreditsIn<20
			gz=gw*(Float(CreditsIn)/20)
		Endif
		
		For x=0 To credx
		For y=0 To credy
			
			q=x-(credx/2)
			If q<1 Then q=q-1
			
			dx=(x*gw)+((p*q)*Abs(q))+cx
			dx=dx-(gz/2)
			
			q=y-(credy/2)
			If q<1 Then q=q-1
			dy=(y*gh)+((p*q)*Abs(q))+cy
			dy=dy-(gz/2)
			
			SetCol(255,255,255)
			If x=0 Or y=0 Or x=credx Or y=credy Then SetCol(0,0,0)
			Rect(dx,dy,gz+1,gz+1)
			
			If x>0 And y>0 And x<credx And y<credy
				SetCol(128,128,128)
				q=2;w=2;e=4;r=4
				If y=(credy-1)
					If x>3 And x<credx-2 Then q=-6;e=-24
					If x=credx-3 Then e=-4
				Endif
				Rect(dx+q,dy+w,gz-e,gz-r)
			Endif

			If x=0 Or y=0 Or x=credx Or y=credy
				SetCol(255,0,0)
				b=(512.0/(credx-2))*(x-1)
				If b<0 Then b=0
				If b>255 Then b=255

				d=512-(512.0/(credx-2))*(x-1)
				If d<0 Then d=0
				If d>255 Then d=255
				
				c=(512.0/(credy-2))*(y-1)
				If c<0 Then c=0
				If c>255 Then c=255
				
				e=512-(512.0/(credy-2))*(y-1)
				If e<0 Then e=0
				If e>255 Then e=255

				f=(255.0/(credx-2))*(x-1)
				If f<0 Then f=0
				If f>255 Then f=255

				If y=0 Then SetCol(b,d,0)
				If x=0 Then SetCol(0,e,c)
				If x=credx Then SetCol(e,0,c)
				If y=credy Then SetCol(f,f,f)
				
				
				q=8;w=8;e=16;r=16
				If x=0 Or x=credx Then q=0;e=0
				If y=0 Or y=credy Then w=0;r=0
				c=1
				If (x=0 And y=0) Or (x=credx And y=0) Then c=0
				If (x=0 And y=credy) Or (x=credx And y=credy) Then c=0

				If c=1 Then Rect(dx+q,dy+w,gz-e,gz-r)
				
			Endif

		Next
		Next

' Middle Circle		
		z=credx
		If Orientation=0 Then z=credy
		Alpha(Float(CreditsIn)/30)
		SetSize(1)
		SetCol(255,255,255)
		DrawImg(91,jscrw/2,(jscrh/2)-(p*24),0)
	
	SetCol(255,255,255)
' Credits
	credscrA=credscrA-0.3
If PlayKeyAll(8) Or PlayKeyAll(0) Then credscrA=credscrA-1.5
	If credscrA<-16 Then credscrA=credscrA+16;credscrB=credscrB+1
		t=CreditText.Length()-1
		Local fp#
		For n=-3 To 4
			fp=Abs(Float(((n)*16)+credscrA)/40 )-0.3
			If fp<0 Then fp=0
			If fp>1 Then fp=1
			Alpha(1-fp)
			m=((n+credscrB) Mod t)
			If m<0 Then m=t+m
			Text((jscrw/2)+24,((jscrh/2)-(p*24))+(n*16)+credscrA,CreditText[m],0.8,0.8)
		Next


' Logo
		Alpha(Float(CreditsIn)/30)
		SetCol(255,255,255)
		SetSize(0.4)
		' Logo
		dy=((credy-1)*gh)+(p*4)+cy
		DrawImg(98,jscrw/2,dy,0)

		ResetDraw()
		Alpha(Float(CreditsIn)/30)
		
		' Actual Res + Update Framerate
		dx=(((1.5)*gw)+cx)-(p*6)
		dy=(((1.5)*gh)+cy)-(p*3)
		SetCol(255,255,255)
		Oval(dx,dy,(gz),(gz))
		SetCol(128,128,128)
		Oval(dx,dy,(gz)-3,(gz)-3)		
		SetCol(255,255,255)
		Text(dx,dy-16,Int(Floor(DeviceWidth())),0.8,0.8)
		Text(dx,dy,Int(Floor(DeviceHeight())),0.8,0.8)
		Text(dx,dy+16,Int(Floor(fpsua)),0.8,0.8)
		
		' Virtual Res + Render Framerate
		dx=(((credx-1.5)*gw)+cx)+(p*6)
		dy=(((1.5)*gh)+cy)-(p*3)
		SetCol(255,255,255)
		Oval(dx,dy,(gz),(gz))
		SetCol(128,128,128)
		Oval(dx,dy,(gz)-3,(gz)-3)
		SetCol(255,255,255)
		Text(dx,dy-16,Int(Floor(jscrw)),0.8,0.8)
		Text(dx,dy,Int(Floor(jscrh)),0.8,0.8)
		Text(dx,dy+16,Int(Floor(fpsra)),0.8,0.8)


		' Bottom Left
		dx=(((1.5)*gw)+cx)-(p*6)
		dy=(((credy-1.5)*gh)+cy)+(p*3)
		SetCol(255,255,255)
		Oval(dx,dy,(gz),(gz))
		SetCol(128,128,128)
		Oval(dx,dy,(gz)-3,(gz)-3)		
		SetCol(255,255,255)
		SetSize(1)
		DrawImg(95,dx,dy,12)
		
		' Bottom Right
		dx=(((credx-1.5)*gw)+cx)+(p*6)
		dy=(((credy-1.5)*gh)+cy)+(p*3)
		SetCol(255,255,255)
		Oval(dx,dy,(gz),(gz))
		SetCol(128,128,128)
		Oval(dx,dy,(gz)-3,(gz)-3)
		SetCol(255,255,255)
		SetSize(0.3)
		DrawImg(93,dx,dy,0)


		
		If mdAll>0 And mdis=0 Then mdis=1;CreditsOn=0;PlaySFX(99)
		If kdis=0 And (PlayKeyAll(15) Or PlayKeyAll(10) Or PlayKeyAll(11)) Then kdis=1;CreditsOn=0;PlaySFX(99)
	End


	Method Old_CreditBox()
		ResetDraw()
		SetCol(255,125,0,0.8)
		Rect(jscrw*0.1,jscrh*0.2,jscrw*0.8,jscrh*0.6)
		SetCol(100,0,0,0.8)
		Rect(jscrw*0.12,jscrh*0.22,jscrw*0.76,jscrh*0.56)
						

		SetCol(255,255,255,1)
		y=0

		SetSize(1.5);If Orientation=0 Then SetSize(1.5)
		Text(jscrw*0.5,jscrh*0.24+y, "A Game By",1);y=y+20
		Text(jscrw*0.5,jscrh*0.24+y, "Jayenkai",1);y=y+20
		Text(jscrw*0.5,jscrh*0.24+y ,"AGameAWeek.com",1);y=y+40

		Text(jscrw*0.5,jscrh*0.24+y ,"Created using",1);y=y+20
		Text(jscrw*0.5,jscrh*0.24+y ,"Monkey",1);y=y+20
		Text(jscrw*0.5,jscrh*0.24+y ,"MonkeyCoder.co.nz",1);y=y+40
		
		If mdAll>0 And mdis=0 Then mdis=1;CreditsOn=0;PlaySFX(99)
	End


	Method BadgesBox()
		ResetDraw()
		SetCol(255,125,0,0.8)
		Rect(jscrw*0.1,-1,jscrw*0.8,jscrh+2)
		SetCol(100,0,0,0.8)
		Rect(jscrw*0.12,-1,jscrw*0.76,jscrh+2)

		SetCol(255,255,255,1)
		y=(BadgesScr)
		q=-1
		If PlayKeyAll(8) Then BadgesAimScr=BadgesAimScr-16
		If PlayKeyAll(0) Then BadgesAimScr=BadgesAimScr+16
		If BadgesAimScr>0 Then BadgesAimScr=0
		
		If md>0 And mx>jscrw*0.12
			d=mwy-my
			BadgesAimScr=BadgesAimScr-d*1.5
		Endif
		
		BadgesScr=BadgesScr-((BadgesScr-BadgesAimScr)/6)
		If Abs(BadgesScr-BadgesAimScr)<6 Then BadgesScr=BadgesAimScr
		
		For b=0 To MaxBadges-1
			If y>-72 And y<jscrh+72
				SetSize(2)
				Alpha(0.5);If Badge[b]=True Then Alpha(1)
				Text(jscrw*0.18,y+16, BadgeName(b));
				If Badge[b]=True
					SetSize(1)
'					Text(jscrw*0.16,y+48,"This is the description of a badge that you've earned")
					If Button(80,jscrw*0.8,y+32,b) Then q=b
				Endif
			Endif
			y=y+72
		Next
			If q>-1
				SetCol(0,40,80,0.7)
				Rect(-1,jscrh*0.5-120,jscrw+2,320)
				SetCol(255,255,255,1)
				SetSize(3);DrawImg(80,jscrw*0.5,jscrh*0.5,q)
				SetSize(1.5)
				Text(jscrw*0.15,jscrh*0.5+120,BadgeDetail(q),0,0)
			Endif
	End

	Method LoadMenu()
		' Organise Scores, Award Highscore, etc..
		g=(GameType-1)*MaxHigh
		u=-1
		
		For n=0 To MaxHigh-1
			If Score>High[g+n] And u=-1 Then u=n
		Next
		
		If u>-1
			For n=MaxHigh-1 To (u+1) Step -1
				High[g+n]=High[g+(n-1)]
			Next
			High[g+u]=Score
		Endif

GC_PostScore(GameType,High[g])
GC_Badges()

		g=g+(MaxGames*MaxHigh)
		
' Last Scores
		For n=MaxHigh-1 To 1 Step -1
			High[g+n]=High[g+(n-1)]
		Next
		High[g]=Score


		Save()
	End

	Method Menu()	
		CLS2D(0,0,80,1)
		If MenuIn<0 Then MenuIn=MenuIn+.25
		
		BarWide=140

#If TARGET="android" Or TARGET="glfw"
	If kdis=0 And mdis=0 And PlayKeyAll(99) And isOuya=0 Then Error("")
#End

If kdis=0 And mdis=0 And (PlayKeyAll(99) Or KeyDown(KEY_ESCAPE)) And isOuya=1 Then GameMode=4;kdis=1;mdis=1


		ResetDraw()
		SetSize(1.5)
		DrawImg(98,jscrw*.4,jscrh*.2+(MenuIn*12),0)
		SetCol(0,0,0,0.4)
		Rect((jscrw-BarWide)-MenuIn*4,0,BarWide,jscrh)
		ResetDraw()

		SetCol(255,255,255,0.75)
		SetSize(1)
		If MaxBadges>0
			If Button(95,32,32+(MenuIn*4),14) And mdis=0
				mdis=1;PlaySFX(99)
				BadgesOn=1-BadgesOn
				If BadgesOn=1 Then BadgesScr=0;BadgesAimScr=0
			Endif
			If isOuya=1 Then Text(32,64+(MenuIn*4),"[L1]",1,1)
			If PlayKeyAll(14) And kdis=0 And BadgesOn<2
					kdis=1;PlaySFX(99)
					BadgesOn=1-BadgesOn
					If BadgesOn=1 Then BadgesScr=0;BadgesAimScr=0			
			Endif

		Endif

		SetCol(255,200,100,1)
		SetSize(1.5)
		g=(GameType-1)*MaxHigh
		
		'	Scoreboards
		
		t=(imgd[J_Font*3+1]*J_Scale_Y)
		s=((jscrh-90))-(jscrh/2)
		
		l=Floor(s/t)
		If l<1 Then l=1
		If l>MaxHigh Then l=MaxHigh
		Local ftxto$="Top "+l
		If l=1 Then ftxto="Highscore"
		For m=0 To l-1
			ftxto=ftxto+"\n"+rstr(High[g+m],11)
		Next
		
		If CreditsOn=0 And BadgesOn=0 And OptionsOn=0 And MenuSelect<MaxGames+1 Then Text(((jscrw-BarWide)-(MenuIn*4))+20,60,ftxto  )

#If TARGET="ios"
	SetCol(255,255,255);SetSize(0.75)
a=0
	If CreditsOn=0 And OptionsOn=0 And BadgesOn=0 And MenuSelect<MaxGames+1 Then a=Button(95,(jscrw-32)-(MenuIn*6),jscrh*.5+8,13)
	If a>0 And mdAll>0 And mdis=0
		mdis=1;
		GC_Scoreboard(GameType)
	Endif
	If gamectr.GameCenterState()>2 Then CreditsOn=1	
#End

		SetCol(200,255,100,1)
		SetSize(1.5)
		g=g+(MaxGames*MaxHigh)
		ftxto="Last "+l
		If l=1 Then ftxto="Last"
		For m=0 To l-1
			ftxto=ftxto+"\n"+rstr(High[g+m],11)
		Next

		If CreditsOn=0 And OptionsOn=0 And BadgesOn=0 And MenuSelect<MaxGames+1 Then Text(((jscrw-BarWide)-(MenuIn*4))+20,jscrh/2+20,ftxto )



'MenuSelect=GameType
If MenuSelect<1 Or MenuSelect>MaxGames+1 Then MenuSelect=1
If MenuSelect=MaxGames+1 Then CogSpin=CogSpin+0.5

g=88	'Gap between buttons

' -=-=-=-=-=-=-=-=-=-====-=-=-=-=-=-=-=-=-=-=-=-=-=-= Menu Buttons
' -=-=-=-=-=-=-=-=-=-====-=-=-=-=-=-=-=-=-=-=-=-=-=-= Menu Buttons

If MenuSelect<MaxGames+1 Then GameType=MenuSelect

If mdAll=0 Then MenuPush=0

MenuScrollAim=MenuScrollAim+MenuAccel
MenuScroll=MenuScroll-((MenuScroll-MenuScrollAim)/8)
If MenuAccel<>0 Then MenuAccel=MenuAccel*0.2
If Abs(MenuAccel)<3 Then MenuAccel=0


MenuOrientation=1-Orientation

y=(jscrh*0.6)+MenuScroll
x=(jscrw-BarWide)/2
j=x;k=(jscrh*0.6)
If MenuOrientation=0
	y=jscrh*0.65
	x=((jscrw-BarWide)*0.5)+MenuScroll
j=((jscrw-BarWide)*0.5);k=y
Endif




SetCol(255,255,255,1)
b=0
c=-1
d=1024
Local falpha#
If CreditsOn=0 And OptionsOn=0 And BadgesOn=0
For n=1 To MaxGames+1

If MenuOrientation=1
	If n=1 And y>jscrh*0.75 Then MenuScrollAim=MenuScrollAim-8;MenuSelect=n
	If n=MaxGames+1 And y<jscrh*0.45 Then MenuScrollAim=MenuScrollAim+8;MenuSelect=n
Endif

If MenuOrientation=0
	If n=1 And x>(jscrw-BarWide)*0.75 Then MenuScrollAim=MenuScrollAim-8;MenuSelect=n
	If n=MaxGames+1 And x<jscrw*0.25 Then MenuScrollAim=MenuScrollAim+8;MenuSelect=n
Endif

'If Abs(y-(jscrh*0.6))<(g*0.45) And Abs(MenuScroll-MenuScrollAim)<16 And MenuSelect<>n And MenuOrientation=1 Then MenuSelect=n;PlaySFX(99)
'If Abs(x-((jscrw-BarWide)*0.5))<(g*0.45) And Abs(MenuScroll-MenuScrollAim)<16 And MenuSelect<>n And MenuOrientation=0 Then MenuSelect=n;PlaySFX(99)


	SetSize(1.0)
	If n=MenuSelect Then SetSize(1.75)
	SetRot(0)

falpha=Sqrt(((x-j)*(x-j))+((y-k)*(y-k)))
If falpha<d Then d=falpha;c=n

falpha=falpha/480.0
If falpha<0 Then falpha=0
If falpha>0.5 Then falpha=0.5
falpha=1-falpha
Alpha(falpha)
If MenuSelect=n Then Alpha(1)

	s=n-1
	If n=MaxGames+1
		SetRot(0-CogSpin*0.66)
		DrawImg(95,x,y,8)
		SetRot((CogSpin*0.33))
		DrawImg(95,x,y,9)
		s=10
		SetRot(CogSpin)
	Endif
	a=Button(95,x,y,s)

	If a And mdis=0 And kdis=0 And MenuSelect<>n
		MenuSelect=n
		MenuScrollAim=0-((n-1)*g)
		MenuAccel=0;MenuPush=0
		MenuFocus=n
		mdis=1;kdis=1
		PlaySFX(99)
	Endif

If MenuSelect=n And n<MaxGames+1 And b=0
b=b+1
	SetSize(3,2.5)
	SetCol(100,255,100,0.3)
	a=a+Button(97,jscrw-70,(jscrh-48)-(MenuIn*4),3)
	SetSize(1);SetCol(255,255,255,1)
Endif

	If a And mdis=0 And kdis=0 And MenuSelect=n
			If MenuSelect<MaxGames+1
				GameType=MenuSelect
				GameMode=11;mdis=1;kdis=1;PlaySFX(98)
			Endif
			If MenuSelect=MaxGames+1
				mdis=1;kdis=1;PlaySFX(98)
				OptionsOn=1;OptionsSelect=0
			Endif	
	Endif


	If MenuOrientation=1 Then y=y+g
	If MenuOrientation=0 Then x=x+g
	
Next

If c>-1 And c<>MenuSelect And MenuFocus=0 Then MenuSelect=c;PlaySFX(99)
If Abs(MenuScroll-MenuScrollAim)<32 And MenuFocus>0 Then MenuFocus=0

'If Abs(y-(jscrh*0.6))<(g*0.45) And Abs(MenuScroll-MenuScrollAim)<16 And MenuSelect<>n And MenuOrientation=1 Then MenuSelect=n;PlaySFX(99)

Endif
' -=-=-=-=-=-=-=-=-=-====-=-=-=-=-=-=-=-=-=-=-=-=-=-= Menu Buttons

		If (PlayKeyAll(0) Or PlayKeyAll(3)) And MenuSelect>1 And kdis=0 And CreditsOn=0 And OptionsOn=0 And BadgesOn=0
			kdis=1;MenuSelect=MenuSelect-1
			MenuFocus=MenuSelect
			PlaySFX(99)
			MenuScrollAim=0-((MenuSelect-1)*g)
			MenuAccel=0
			MenuPush=0
		Endif
		If (PlayKeyAll(8) Or PlayKeyAll(5)) And MenuSelect<MaxGames+1 And kdis=0 And CreditsOn=0 And OptionsOn=0 And BadgesOn=0
			kdis=1;MenuSelect=MenuSelect+1
			MenuFocus=MenuSelect
			PlaySFX(99)
			MenuScrollAim=0-((MenuSelect-1)*g)
			MenuAccel=0
			MenuPush=0
		Endif

		If (PlayKeyAll(10) Or PlayKeyAll(11) Or PlayKeyAll(12) Or PlayKeyAll(13) Or PlayKeyAll(16) Or PlayKeyAll(17)) And kdis=0 And CreditsOn=0 And OptionsOn=0 And BadgesOn=0
			If MenuSelect<MaxGames+1
				GameType=MenuSelect
				GameMode=11;mdis=1;kdis=1;PlaySFX(98)
			Endif
			If MenuSelect=MaxGames+1
				mdis=1;kdis=1;PlaySFX(98)
				OptionsOn=1;OptionsSelect=0
			Endif
		Endif

		ResetDraw()
'If iCadeAllowed=1 And isOuya=0
'		If Button(92,jscrw-38,38+(MenuIn*4),iCadeControls) And CreditsOn=0 And OptionsOn=0 And BadgesOn=0
'			If mdis=0 And iCadeControls=0 Then mdis=1;iCade(1);PlaySFX(99)
'			If mdis=0 And iCadeControls=1 Then mdis=1;iCade(0);PlaySFX(99)
'		Endif
'Endif

		SetSize(0.5)
		If kdis=0 And PlayKeyAll(15) And CreditsOn=0 And OptionsOn=0 And BadgesOn=0
			kdis=1
			PlaySFX(99)
			CreditsOn=1
		Endif
		SetSize(0.35)
		If Button(93,(jscrw-70),(32)+(MenuIn*4),0) And mdis=0 And CreditsOn=0 And OptionsOn=0 And BadgesOn=0
			mdis=1
			PlaySFX(99)
			CreditsOn=1
		Endif	
		
		

' Menu Scrolly
If mdis<>1 And CreditsOn=0 And OptionsOn=0 And BadgesOn=0
	If mdAll>0
		If MenuOrientation=1 Then MenuPush=(Float(my-mwy)*1.5)
		If MenuOrientation=0 Then MenuPush=(Float(mx-mwx)*1.5)
		If MenuPush<-2 Or MenuPush>2
			MenuAccel=MenuAccel+MenuPush
			mdis=2
		Endif
	Endif
Endif

		
	End

	Method GameOver()
	If Ending>0
		Local floaty#=Float(Ending)/40
		If floaty>0.7 Then floaty=0.7
		SetCol(0,0,0,floaty)
		Rect(-1,-1,jscrw+2,jscrh+2)
		
		y=Ending*12;If y>jscrh*.45 Then y=jscrh*.45
		ResetDraw()
		SetCol(255,255,0,0.5)
		Rect(-1,(jscrh*.45)-8,y*2,16)
		SetCol(255,128,0,0.5)
		Rect(jscrw-y*2,jscrh*0.55-8,(y*2)+1,16)
		
		ResetDraw()
		SetSize(4)
		SetCol(255,180,180,1)
		Text(jscrw*.35,y,"GAME",1,1)
		Text(jscrw*.65,jscrh-y,"OVER",1,1)
		
		Local ftxtt$=MyNth()
		If n>0
			SetSize(1)
			SetCol(0,125,255,0.5)
			Rect(jscrw*.35,(jscrh-(Float(y)/1.5))-16,jscrw*0.3,32)
			SetSize(2)
			SetCol(100,255,100,1)
			Text(jscrw*.5,jscrh-(Float(y)/1.5),"New Highscore\n           "+MyNth(),0.5,2)	
		Endif
	Endif
		
		If GameMode=10
			Ending=Ending+1
			If Ending=90
				GameMode=2;Ending=75;
				MusicPlayer.JM_Stop(1)
				If HasMusic=1 Then MusicPlayer.JM_Stop(1)
				If HasMusicStream=1 Then StopTune()
			Endif
		Endif
		If GameMode<10
			Ending=Ending-2
			If Ending<0 Then Ending=0
		Endif
	End


' -=-=-=-=-=-=-=-=
'	Effects
' -=-=-=-=-=-=-=-=

	Method ResetStars(newfigure=-1)
	If newfigure>0 And newfigure<500 Then MostStars=newfigure	
	Local astar

		For astar=0 To MostStars
			Star[astar*10]=Rand(0,255)		' sprite number from parts.png
			Star[astar*10+1]=Rnd(-8,jscrw+8)	' x
			Star[astar*10+2]=Rnd(-8,jscrh+8)	' y
			Star[astar*10+3]=Rnd(0.2,0.8)	' depth
			Star[astar*10+5]=Rnd(0,360)		' rotation
			Star[astar*10+6]=Rnd(-0.5,0.5)	' add rotation
		Next
	End
	
	Method DoStars(movex#=-1.0,movey#=0)
	Local astar
		ResetDraw()
		For astar=0 To MostStars
			Star[astar*10+1]=Star[astar*10+1]+(movex*Star[astar*10+3])
			Star[astar*10+2]=Star[astar*10+2]+(movey*Star[astar*10+3])
			If Star[astar*10+1]<-(16+overscan)
				Star[astar*10+1]=Star[astar*10+1]+(jscrw+(32+(overscan*2)))
				Star[astar*10+2]=Rnd(-8,jscrh+8)
				Star[astar*10+3]=Rnd(0.2,0.8)
				Star[astar*10]=Rand(0,255)
			Endif

			If Star[astar*10+1]>jscrw+(16+overscan)
				Star[astar*10+1]=Star[astar*10+1]-(jscrw+(32+(overscan*2)))
				Star[astar*10+2]=Rnd(-8,jscrh+8)
				Star[astar*10+3]=Rnd(0.2,0.8)
				Star[astar*10]=Rand(0,255)
			Endif


			If Star[astar*10+2]<-(16+overscan)
				Star[astar*10+2]=Star[astar*10+2]+(jscrh+(32+(overscan*2)))
				Star[astar*10+1]=Rnd(-8,jscrw+8)
				Star[astar*10+3]=Rnd(0.2,0.8)
				Star[astar*10]=Rand(0,255)
			Endif

			If Star[astar*10+2]>jscrh+(16+overscan)
				Star[astar*10+2]=Star[astar*10+2]-(jscrh+(32+(overscan*2)))
				Star[astar*10+1]=Rnd(-8,jscrw+8)
				Star[astar*10+3]=Rnd(0.2,0.8)
				Star[astar*10]=Rand(0,255)
			Endif
			
			Star[astar*10+5]=Star[astar*10+5]+Star[astar*10+6]
			Alpha(Star[astar*10+3])
			DrawImg(96,Star[astar*10+1],Star[astar*10+2],Star[astar*10])
		Next
		ResetDraw()
	End


	Method ResetParticles(newfigure=-1)
	If newfigure>0 And newfigure<500 Then MostParticles=newfigure
	Local apart
		For apart=0 To MostParticles
			Part[apart*10]=0				
		Next
	End
	
	Method FreeParticle()
		Local fn,fc=-1
			For fn=0 To MostParticles
				If Part[fn*10]=0 Then fc=fn*10
			Next
		Return fc
	End

	Method AddParticle(fType,fx#,fy#,fgx#,fgy#,fparam=0,fparam2=0,flife=0)
		Local ff=FreeParticle()
		If ff>-1
			Part[ff]=fType
			Part[ff+1]=fx
			Part[ff+2]=fy
			Part[ff+3]=fgx
			Part[ff+4]=fgy
			Part[ff+5]=Rand(0,360)
			Part[ff+6]=Rnd(-7,7)
			Part[ff+7]=1+flife
			Part[ff+8]=fparam2
			Part[ff+9]=fparam
		Endif
	End
	
	Method DoParticles()
	ResetDraw()
	Local apart,ID2
		For apart=0 To MostParticles
		ID2=apart*10
			If Part[ID2]>0
				Part[ID2+1]=Part[ID2+1]+Part[ID2+3]
				Part[ID2+2]=Part[ID2+2]+Part[ID2+4]
				Part[ID2+5]=Part[ID2+5]+Part[ID2+6]
				SetRot(Part[ID2+5])
				
				' 99 - Score
				If Part[ID2]=99 Then SetRot(0)
				
				' 2 - Gravity drags down
				If Part[ID2]=2 Then Part[ID2+3]=Part[ID2+3]*0.95;Part[ID2+4]=Part[ID2+4]+0.2
				
				
				Alpha(Part[ID2+7])
				If Part[ID2+7]>1 Then Alpha(1)
				SetSize(1);J_R=255;J_G=255;J_B=255
				
#If TARGET<>"html5"
				Ink(Part[ID2+8])
#End

				
				If Part[ID2]>0 And Part[ID2]<10
					DrawImg(96,Part[ID2+1]-scrx,Part[ID2+2]-scry,Part[ID2+9])
				Endif
				
				If Part[ID2]=99
					SetSize(3)
					Text(Part[ID2+1],Part[ID2+2],Int(Part[ID2+9]),1,1)
				Endif
				
				
				Part[ID2+7]=Part[ID2+7]-0.01
				If Part[ID2+7]<0 Then Part[ID2]=0
				
			Endif

		Next
		ResetDraw()
	End

	Method ThrowParticle(fx#,fy#,ftype=1,fink=9,fdirection#=-3717,fpower#=-3717)
		If fdirection=-3717 Then fdirection=Rnd(0,360)
		If fpower=-3717 Then fpower=Rnd(3,8)
		Local ff=FreeParticle()
		If ff>-1
			Part[ff]=ftype
			Part[ff+1]=fx
			Part[ff+2]=fy
			Part[ff+3]=Sin(fdirection)*fpower
			Part[ff+4]=-Cos(fdirection)*fpower
			Part[ff+5]=Rnd(0,360)
			Part[ff+6]=Rnd(-8,8)
			Part[ff+7]=Rnd(0.7,1.3)
			Part[ff+8]=fink
			Part[ff+9]=Rand(0,255)
		Endif
	End
	
	
	Method Gimme(fScore,fx#,fy#)
		Score=Score+fScore
		AddParticle(99,fx,fy,0,-0.25,fScore,3)
	End


	Method ResetPlayers()
		For n=0 To 499
		plr[n]=0
		Next
	End

' -=-=-=-=-=-=-=-=
'	Your Game
' -=-=-=-=-=-=-=-=
	


	Method LoadGame()
		Paused=0
		' Reset all your variables here
		Score=0
		EndofGame=0
		Ending=0
		GameMode=10
		
		scrx=0;scry=0
		aimx=0;aimy=0
		
		If HasMusicStream=1
'			PlayTune("testmusic")
		Endif
		
		If HasMusic=1
			If GameType=1 Then MusicPlayer.JM_StartTune("Sheep Goes Left/Tune_12",37171650,100)
			If GameType=2 Then MusicPlayer.JM_StartTune("Retro/Manic Miner",37171650,100)
			If GameType=3 Then MusicPlayer.JM_StartTune("Retro/MarioEsque",37171650,100)
		Endif
		
		ResetStars(100)
		ResetParticles(250)
		ResetPlayers()
	
		For n=1 To 4
			plr[n*100]=1
			plr[n*100+1]=128
			plr[n*100+2]=(Float(jscrh/5)*(Float(n)))
		Next


MaxSpike=0
SpikeTo=1
SpikePassed=0
SpikeCount=0
spikex=jscrw
Combo=0;ComboTick=0;SCombo=0

	For m=0 To 100
		AddSpike()
	Next
	
	End

	Method AddSpike()
		For n=0 To 99
		grid[n]=grid[n+1]
		grid[n+200]=grid[n+201]
		Next
		grid[100]=Rnd(0,(Float(MaxSpike)+0.99))
		If grid[100]<0 Then grid[100]=0
		If grid[100]>9 Then grid[100]=9
		grid[300]=SpikeTo;SpikeTo=SpikeTo+1
		SpikeCount=SpikeCount+1
		If SpikeCount>4 Then SpikeCount=0;MaxSpike=MaxSpike+1
		If MaxSpike>9 Then MaxSpike=9
	End


	Method DrawSpike(fx#,fhigh#)
		Local fz#=(jscrh/12.0)
		Local fzs#=fz/32.0
		Local fy
		Local fc=fhigh+10
		fhigh=(fhigh/2.0)

		fy=(FloorAt-(fz/2))-(fz*fhigh)
		If plr[10]>0 Then DrawImg(1,fx,fy,fc)
		If Abs(fx-plr[1])<fz*0.9 And Abs(fy-plr[2])<fz*0.9 And plr[10]=0
			plr[10]=1;PlaySFX(5);PlaySFX(6)
		Endif


		fy=(FloorAt+8)+(fz/2)+(fz*fhigh)
		DrawImg(1,fx,fy,fc)
	End


	Method Game()
		CLS2D(0,0,80,1)
Local dx#,dy#,ID
dx=((scrx-aimx)/8)
dy=((scry-aimy)/8)
scrx=scrx-dx
scry=scry-dy

ResetDraw()

'AnalogueControl();ResetDraw()

' ********************* Delete this shite, then add your own! v

Local fz#=(jscrh/12.0)
Local fzs#=fz/32.0
FloorAt=(jscrh/2)-4
SetCol(80,0,0)
Rect(0-(64+(overscan*4)),jscrh/2-4,jscrw+(64+(overscan*8)),jscrh)
SetCol(100,255,100)
Rect(0-(64+(overscan*4)),jscrh/2-4,jscrw+(64+(overscan*8)),8)
DoStars(dx,dy)

s=6
If Paused=0 And EndofGame=0 And plr[10]=0 Then plr[3]=plr[3]+3.0
If plr[3]>180 Then plr[3]=plr[3]-180;PlaySFX(3)

g=200

a=0
a=a+mdAll+PlayKey(0)+PlayKey(3)+PlayKey(5)+PlayKey(8)+PlayKey(10)+PlayKey(11)+PlayKey(12)

If a=0 Then SCombo=0
If a<>0 And plr[10]=0 And Paused=0 And EndofGame=0
	scrx=scrx-s
	spikex=spikex-s
Endif

plr[1]=32
plr[2]=(jscrh/2)-Abs(Sin(plr[3])*(fz*4.5))-(fz/2)
ResetDraw();SetSize(fzs)
DrawImg(1,plr[1],plr[2],0)

ResetDraw()

SetSize(fzs)
If spikex<-(g*2)
	spikex=spikex+g;AddSpike()
Endif

x=spikex
Local fp#=1

For n=0 To 100
	DrawSpike(x,grid[n])
	If x+fz<plr[1] And grid[n+200]>SpikePassed
		SpikePassed=SpikePassed+1
		SCombo=SCombo+1
		Combo=Combo+1
		ComboTick=90
		Gimme((Combo*SCombo),Rnd(100,jscrw-100),Rnd(64,jscrh/2))
		If SCombo=1 Then PlaySFX(2,fp)
		If SCombo>1 Then PlaySFX(4,fp)
	Endif
	x=x+g
Next



DoParticles()
' **************  Your game goes ^ here ^

	'	Score Display
		ShowScore=ShowScore-((ShowScore-Score)/6);If Abs(ShowScore-Score)<6 Then ShowScore=Score

If ScreenshotMode=0
		ResetDraw();SetCol(100,255,100,0.8)
		SetSize(2)
		Text(jscrw/2,16,rstr(ShowScore,8,"0"),1,1)

		SetCol(100,255,100,1)
		Rect((jscrw/2-(90*2))-2,30,(90*4)+4,20)
		SetCol(0,80,0,1)
		Rect(jscrw/2-(90*2),32,(90*4),16)
		
	If ComboTick>0
		SetCol(100,255,100,1)
		Rect(jscrw/2-(ComboTick*2),32,(ComboTick*4),16)
	Endif
Endif

If ComboTick>0 And plr[10]=0 And Paused=0 And EndofGame=0 Then ComboTick=ComboTick-1.5
If ComboTick<1
	If Combo>0 Then PlaySFX(10)
	ComboTick=0;Combo=0;SCombo=0
Endif

If plr[10]>0 Then plr[10]=plr[10]+1
If plr[10]>60 Then EndofGame=1

	End	Method
	
End


Function Main()
	New MyApp
End


Extern
#If TARGET="html5"
	Function GoFullscreen:Int()="GoFullscreen_Monkey"
#End
